/*********************************************************************/
/*                  pC++/Sage++  Copyright (C) 1993                  */
/*  Indiana University  University of Oregon  University of Rennes   */
/*********************************************************************/


//dep2C++ generated
#include "runtime.h"
class  SuperKernel__Vector ;
class  DistributedArray__Vector ;
class  DistVector__Vector ;
class GVars {
public:
int VarpC_9;
int VarpC_8;
int VarpC_7;
int VarpC_6;
int VarpC_5;
int VarpC_4;
int VarpC_3;
int VarpC_2;
int VarpC_1;
int VarpC_0;
float *wr[20];
float *wi[20];
int p[1024];
} *GlobalVars;
extern unsigned long  int ev_class;
extern "C" {
       extern  void  se_init(char *n);
       extern  void  se_event(int e, long int p);
       extern  void  se_long_event(int e, int l, char *p);
       extern  void  se_close();
       extern  void  se_flush();
       extern  void  se_set_and_parse_eventclass(char *p, char *c);
}
int  mylog2(int n){

       int x;
       x = 0;
       while ((n) >  (1))
       {
          n = (n) / (2);
          (x)++;
        }
       return x;
}
class  Vector {
public:
public:
       Vector  *Self(int i, int j);
public:
       Vector  *Self(int i);
public:
       SuperKernel__Vector  *ThisCollection;
public:
       int index2;
public:
       int index1;
public:
       int Ident;
public:
       void  DeleteTemp();
public:
       void  LocalShiftStep2();
public:
       void  LocalShiftStep1(int dim, int distance);
public:
       void  LocalBroadcastDim2(DistributedArray__Vector *array, int step);
public:
       void  LocalReduceDim2(DistributedArray__Vector *array, int step);
public:
       void  LocalBroadcastDim1(DistributedArray__Vector *array, int step);
public:
       void  LocalBroadcast(DistributedArray__Vector *array, int step);
public:
       void  LocalReduceDim1(DistributedArray__Vector *array, int step);
public:
       void  LocalReduce(DistributedArray__Vector *array, int step);
public:
       void  Set_ThisCollection(DistributedArray__Vector *C);
public:
       void  LocalCopy(DistributedArray__Vector *array);
public:
       void  BroadcastTemp(DistributedArray__Vector &array, int step);
public:
       void  LocalGSum(DistributedArray__Vector &array, int step);
public:
       void  ResetDotProd(DistributedArray__Vector &arg1);
public:
       Vector  *temporaryelement;
public:
       double dotprodtemp;
public:
       void  WhereAmI();
public:
       double  Dot(Vector &arg1){
       
          return 0.0;
       }
public:
       void  DoSubSetBackward(int start, int end, int step, int s, DistVector__Vector &coll);
public:
       void  DoSubSetForward(int start, int end, int step, int s, DistVector__Vector &coll);
public:
       void  ParBackSolve(int s, DistVector__Vector &coll);
public:
       void  ParForwardElim(int s, DistVector__Vector &coll);
public:
       void  ParVector_copy(DistVector__Vector &coll);
public:
       void  ParSinTransform(float **wr, float **wi, int *p, DistVector__Vector &coll);
public:
       void  ForwardElim(int s, Vector *result);
public:
       void  BackSolve(int s, Vector *result);
private:
       int n;
private:
       int log2n;
private:
       float vals[((8) * (64)) + (8)];
private:
       float  *tmp1;
public:
       Vector operator +(Vector &rhs);
public:
       Vector operator *(Vector &rhs);
public:
       Vector  &operator =(Vector &rhs);
public:
       Vector  &operator +=(Vector &rhs);
public:
         Vector(){
       
          n = 0;
          log2n = 0;
       }
public:
         Vector(int size){
       
          n = (size) -(1);
          log2n = mylog2(n);
          tmp1 = new float [size] ;
       }
public:
       void   allocData(int size){
       
          n = (size) -(1);
          log2n = mylog2(n);
          tmp1 = new float [size] ;
       }
public:
       void   resize(int size){
       
          n = (size) -(1);
          if ((size) >  (((8) * (64)) + (8))) 
          {
             Message("Vector to big",1);
           }
           log2n = mylog2(n);
       }
public:
       void   Vector_copy(Vector *v){
       
          int i;
          for (i = 0 ; (i)<=(n) ; (i)++)
          {
             vals[i] = (v)->vals[i];
           }
       }
public:
       void   put(float v, int i){
       
          if (((i) < (0)) || ((i) >  (((8) * (64)) + (8)))) 
          {
             Message("Error in Put",1);
           }
           vals[i] = v;
       }
public:
       float  get(int i){
       
          if (((i) < (0)) || ((i) >  (((8) * (64)) + (8)))) 
          {
             Message("Error in Get",1);
           }
           return vals[i];
       }
public:
       void  ComplexFourierTransform(float **wr, float **wi, int *p, Vector *result);
public:
       void  SinTransform(float **wr, float **wi, int *p, Vector *result);
public:
       void  SolveTridiag(float a, float b, Vector *result);
public:
       void  SolveTridiag2(float a, float b, float **wr, float **wi, int *p, Vector *result);
public:
       void  SolveTridiag3(float ar, float br, Vector *result);
 
};
Vector Vector:: operator +(Vector &rhs){

       Vector T(n);
       int i;
       for (i = 0 ; (i) < (n) ; (i)++)
       {
          T.vals[i] = ((this )->vals[i]) + (rhs.vals[i]);
        }
       return T;
}
Vector Vector:: operator *(Vector &rhs){

       Vector T(n);
       int i;
       for (i = 0 ; (i) < (n) ; (i)++)
       {
          T.vals[i] = ((this )->vals[i]) * (rhs.vals[i]);
        }
       return T;
}
Vector & Vector:: operator =(Vector &rhs){

       int i;
       n = rhs.n;
       for (i = 0 ; (i) < (n) ; (i)++)
       {
          (this )->vals[i] = rhs.vals[i];
        }
       return *(this );
}
Vector & Vector:: operator +=(Vector &rhs){

       int i;
       n = rhs.n;
       for (i = 0 ; (i) < (n) ; (i)++)
       {
          (this )->vals[i] += rhs.vals[i];
        }
       return *(this );
}
void   step(int hn, float *ar, float *ai, float *wr, float *wi, float *cr, float *ci){

       int i;
       float tr,ti;
       for (i = 0 ; (i) < (hn) ; (i)++)
       {
          tr = ((wr[i]) * (ar[(hn) + (i)])) -((wi[i]) * (ai[(hn) + (i)]));
          ti = ((wr[i]) * (ai[(hn) + (i)])) + ((wi[i]) * (ar[(hn) + (i)]));
          cr[(2) * (i)] = (ar[i]) + (tr);
          cr[((2) * (i)) + (1)] = (ar[i]) -(tr);
          ci[(2) * (i)] = (ai[i]) + (ti);
          ci[((2) * (i)) + (1)] = (ai[i]) -(ti);
        }
}
void  Vector:: ComplexFourierTransform(float **wr, float **wi, int *p, Vector *result){

       int togle,i;
       int logn;
       float  *xr,*xi,*yr,*yi;
       logn = (log2n) -(1);
       xr = &((this )->vals[0]);
       xi = &((this )->vals[(n) / (2)]);
       yr = &((result)->vals[0]);
       yi = &((result)->vals[(n) / (2)]);
       togle = 1;
       for (i = 0 ; (i) < (logn) ; (i)++)
       {
          if ((togle) == (1)) 
          {
             step((n) / (4),xr,xi,wr[i],wi[i],yr,yi);
             togle = 0;
           }
           else{
             step((n) / (4),yr,yi,wr[i],wi[i],xr,xi);
             togle = 1;
           }
        }
       if (((2) * ((logn) / (2)))!=(logn)) 
       {
          for (i = 0 ; (i) < ((n) / (2)) ; (i)++)
          {
             xr[i] = yr[i];
             xi[i] = yi[i];
           }
        }
        for (i = 0 ; (i) < ((n) / (2)) ; (i)++)
       {
          yr[i] = xr[p[i]];
          yi[i] = xi[p[i]];
        }
}
int  rev(int k, int i){

       int x,j,leadbit;
       x = 0;
       for (j = 0 ; (j) < (k) ; (j)++)
       {
          if (((2) * ((i) / (2)))!=(i)) 
          {
             leadbit = 1;
           }
           else{
             leadbit = 0;
           }
          i = ((i) -(leadbit)) / (2);
          x = ((2) * (x)) + (leadbit);
        }
       return x;
}
void   initw(int n, int log2n, float **wr, float **wi, int *p){

       int i,j,k,m;
       double x;
       x = ((2.0e0) * (3.14159265358979323846e0)) / (n);
       for (i = 0 ; (i) < (log2n) ; (i)++)
       {
          wr[i] = new float [n] ;
          wi[i] = new float [n] ;
        }
       for (i = 0 ; (i) < ((n) / (2)) ; (i)++)
       {
          p[i] = rev((log2n) -(1),i);
        }
       for (i = 0 ; (i) < ((n) / (2)) ; (i)++)
       {
          wr[(log2n) -(1)][p[i]] = (float) cos((x) * (i));
          wi[(log2n) -(1)][p[i]] = (float) sin((x) * (i));
        }
       m = 1;
       for (i = 0 ; (i) < ((log2n) -(1)) ; (i)++)
       {
          for (j = 0 ; (j) < ((n) / (2)) ; (j)++)
          {
             k = (m) -(1)&j;
             wr[i][j] = wr[(log2n) -(1)][k];
             wi[i][j] = wi[(log2n) -(1)][k];
           }
          m = (2) * (m);
        }
       for (i = 0 ; (i) < (n) ; (i)++)
       {
          p[i] = rev(log2n,i);
        }
}
void  Vector:: SinTransform(float **wr, float **wi, int *p, Vector *result){

       int i;
       double c,s,k;
       float x,t1,tnm1;
       float  *y,*a,*b,*z;
       y = (this )->vals;
       a = (this )->tmp1;
       b = (result)->tmp1;
       z = (result)->vals;
       t1 = y[1];
       tnm1 = y[(n) -(1)];
       for (i = 1 ; (i) < (n) ; (i)++)
       {
          a[i] = (0.5) * ((y[i]) + (y[(n) -(i)]));
          b[i] = (0.5) * ((y[i]) -(y[(n) -(i)]));
        }
       a[0] = y[0];
       b[0] = 0.0;
       x = ((2.0) * (3.14159265358979323846e0)) / (n);
       for (i = 1 ; (i) < ((n) / (2)) ; (i)++)
       {
          c = cos((x) * (i));
          s = sin((x) * (i));
          z[i] = ((( (-(s))) * ((a[((2) * (i)) + (1)]) -(a[((2) * (i)) -(1)]))) + ((c) * (a[(2) * (i)]))) + ((b[((2) * (i)) + (1)]) -(b[((2) * (i)) -(1)]));
          z[((n) / (2)) + (i)] = (( (-(b[(2) * (i)]))) + ((c) * ((a[((2) * (i)) + (1)]) -(a[((2) * (i)) -(1)])))) + ((s) * (a[(2) * (i)]));
        }
       z[0] = (t1) -(tnm1);
       z[(n) / (2)] = (t1) + (tnm1);
       (result)->ComplexFourierTransform(wr,wi,p,this );
       for (i = 0 ; (i) < ((n) / (2)) ; (i)++)
       {
          a[(2) * (i)] = y[i];
          a[((2) * (i)) + (1)] = y[((n) / (2)) + (i)];
        }
       x = (3.14159265358979323846e0) / (n);
       k = sqrt((double) (2.0) / (n));
       for (i = 1 ; (i) < (n) ; (i)++)
       {
          s = sin((x) * (i));
          s = (0.25) / (s);
          z[i] = (k) * (((a[i]) * ((0.5) + (s))) + ((a[(n) -(i)]) * ((s) -(0.5))));
        }
}
void  Vector:: SolveTridiag(float a, float b, Vector *result){

       int i;
       float  *x,*y,*diag;
       double c;
       y = (this )->vals;
       x = (result)->vals;
       diag = (this )->tmp1;
       diag[1] = a;
       x[1] = y[1];
       for (i = 1 ; (i) < ((n) -(1)) ; (i)++)
       {
          c = (b) / (diag[i]);
          diag[(i) + (1)] = (a) -((b) * (c));
          x[(i) + (1)] = (y[(i) + (1)]) -((c) * (x[i]));
        }
       x[(n) -(1)] = (x[(n) -(1)]) / (diag[(n) -(1)]);
       for (i = (n) -(2) ; (i) >  (0) ; (i)--)
       {
          x[i] = ((x[i]) -((b) * (x[(i) + (1)]))) / (diag[i]);
        }
       x[0] = 0.0;
       x[n] = 0.0;
}
void  Vector:: SolveTridiag2(float a, float b, float **wr, float **wi, int *p, Vector *result){

       int i;
       float  *x,*y;
       y = (this )->vals;
       x = (result)->vals;
       SinTransform(wr,wi,p,result);
       for (i = 1 ; (i) < (n) ; (i)++)
       {
          double gamma;
          gamma = ((3.14159265358979323846e0) * (i)) / (n);
          gamma = (a) + (((2.0) * (b)) * ((float) cos(gamma)));
          x[i] = (x[i]) / (gamma);
        }
       (result)->SinTransform(wr,wi,p,this );
       for (i = 1 ; (i) < (n) ; (i)++)
       {
          x[i] = ((y[i]) * (2.0)) / (n);
        }
       x[0] = 0.0;
       x[n] = 0.0;
}
void  Vector:: SolveTridiag3(float ar, float br, Vector *result){

       int i,s;
       float  *x,*y,*a,*b;
       double c;
       a = (this )->tmp1;
       b = (result)->tmp1;
       x = (result)->vals;
       y = (this )->vals;
       for (i = 1 ; (i) < (n) ; (i)++)
       {
          a[i] = ar;
          b[i] = br;
        }
       for (s = 1 ; (s) < ((n) / (2)) ; s = (2) * (s))
       {
          for (i = (2) * (s) ; (i) < (n) ; i = (i) + ((2) * (s)))
          {
             c = (b[i]) / (a[i]);
             a[i] = (a[i]) -(((c) * (2)) * (b[i]));
             b[i] = ( (-(c))) * (b[i]);
             y[i] = (y[i]) -((c) * ((y[(i) -(s)]) + (y[(i) + (s)])));
           }
        }
       x[0] = 0.0;
       x[n] = 0.0;
       for (s = (n) / (2) ; (s)>=(1) ; s = (s) / (2))
       {
          for (i = s ; (i) < (n) ; i = (i) + ((2) * (s)))
          {
             x[i] = ((y[i]) -((b[i]) * ((x[(i) -(s)]) + (x[(i) + (s)])))) / (a[i]);
           }
        }
}
struct INFO_HEAD {
       int LocalTraversalCount;
       char  *CurrentCollectionTraversal;
       int type;
       int number_dimension;
       int element_size;
       int nb_element;
       int dim1size,dim2size,dim3size;
       int  **Table;
       int  **Where;
} ;
typedef  struct INFO_HEAD *PTR_INFO;
typedef  struct  {
       int numproc;
       int eventclass;
       char  *tracefile;
       int numthread;
       int shmemsize;
       int stacksize;
} pCC_PARAM_t;
class  Processors {
public:
public:
       int dimension;
 
};
class  Distribution {
public:
public:
       int nbdim;
public:
       int nbelement;
public:
       int dim1size,dim2size,dim3size;
public:
       int dist1,dist2,dist3;
public:
       Processors P;
public:
        Distribution();
public:
        Distribution(int d1size, Processors *P, int dt1);
public:
        Distribution(int d1size, int d2size, Processors *P, int dt1, int dt2);
public:
        Distribution(int d1size, int d2size, int d3size, Processors *P, int dt1, int dt2, int dt3);
public:
       int GiveElementProc(int i);
public:
       int GiveElementProc(int i, int j);
public:
       int GiveElementProc(int i, int j, int k);
 
};
 Distribution:: Distribution(){

       nbdim = 1;
       nbelement = pcxx_TotalNodes();
       dim1size = pcxx_TotalNodes();
       dist1 = 2;
}
 Distribution:: Distribution(int d1size, Processors *P, int dt1){

       nbdim = 1;
       nbelement = d1size;
       dim1size = d1size;
       dist1 = dt1;
}
 Distribution:: Distribution(int d1size, int d2size, Processors *P, int dt1, int dt2){

       nbdim = 2;
       nbelement = (d1size) * (d2size);
       dim1size = d1size;
       dim2size = d2size;
       dist1 = dt1;
       dist2 = dt2;
}
 Distribution:: Distribution(int d1size, int d2size, int d3size, Processors *P, int dt1, int dt2, int dt3){

       nbdim = 2;
       nbelement = ((d1size) * (d2size)) * (d3size);
       dim1size = d1size;
       dim2size = d2size;
       dim3size = d3size;
       dist1 = dt1;
       dist2 = dt2;
       dist3 = dt3;
       Message("Distribution(): Sorry, 3D template not implemented.",1);
}
int Distribution:: GiveElementProc(int i){

       int proc = 0;
       int x,p,rem,q;
       switch (dist1)
       {
          case 1:
          p = (dim1size) / (pcxx_TotalNodes());
          rem = (dim1size) -((pcxx_TotalNodes()) * (p));
          q = ((p)<=(rem))?(p) + (1):p;
          proc = (i) / (q);
          if ((proc)>=(pcxx_TotalNodes())) 
          {
             proc = ((pcxx_TotalNodes()) -(1)) -((proc)% (pcxx_TotalNodes()));
           }
           break;
          case 2:
          proc = (i)% (pcxx_TotalNodes());
          break;
          case 3:
          Message("GiveElementProc()_1D: WHOLE has no meaning in 1D Distribution,",0);
          Message("GiveElementProc()_1D: use BLOCK distribution instead.",0);
          p = (dim1size) / (pcxx_TotalNodes());
          rem = (dim1size) -((pcxx_TotalNodes()) * (p));
          q = ((p)<=(rem))?(p) + (1):p;
          proc = (i) / (q);
          if ((proc)>=(pcxx_TotalNodes())) 
          {
             proc = ((pcxx_TotalNodes()) -(1)) -((proc)% (pcxx_TotalNodes()));
           }
           break;
          default:
          Message("GiveElementProc()_1D: Unknow distribution for 1D Distribution.",1);
        }
       if ((proc)>=(pcxx_TotalNodes())) 
       {
          Message("GiveElementProc()_1D: Error in 1D Distribution object.",0);
          proc = (proc)% (pcxx_TotalNodes());
        }
        return proc;
}
int Distribution:: GiveElementProc(int i, int j){

       int proc = 0;
       int index1,index2,sq,p,rem,q;
       float x,y;
       if (((dist1) == (4)) && ((dist2) == (4))) 
       {
          q = (int) QGridToProc(i,j,dim1size);
          x = ((dim1size) * (dim2size)) / ((float) pcxx_TotalNodes());
          y = (q) / (x);
          proc = (int) y;
          if ((proc)>=(pcxx_TotalNodes())) 
          {
             Message("GiveElementProc()_2D: Processor # Out of Bounds)",0);
             proc = (proc)% (pcxx_TotalNodes());
           }
           return proc;
        }
        sq = (int) sqrt((double) pcxx_TotalNodes());
       switch (dist1)
       {
          case 1:
          p = (dim1size) / (sq);
          rem = (dim1size) -((sq) * (p));
          q = ((p)<=(rem))?(p) + (1):p;
          index1 = (i) / (q);
          if ((index1)>=(sq)) 
          {
             index1 = ((sq) -(1)) -((index1)% (sq));
           }
           break;
          case 2:
          index1 = (i)% (sq);
          break;
          case 3:
          index1 = 0;
          break;
          default:
          Message("GiveElementProc()_2D: Unknow distribution for 2D Distribution.",1);
        }
       switch (dist2)
       {
          case 1:
          p = (dim2size) / (sq);
          rem = (dim2size) -((sq) * (p));
          q = ((p)<=(rem))?(p) + (1):p;
          index2 = (j) / (q);
          if ((index2)>=(sq)) 
          {
             index2 = ((sq) -(1)) -((index2)% (sq));
           }
           break;
          case 2:
          index2 = (j)% (sq);
          break;
          case 3:
          index2 = 0;
          break;
          default:
          Message("GiveElementProc()_2D: Unknow distribution for 2D Distribution.",1);
        }
       proc = (index1) + ((index2) * (sq));
       if ((proc)>=(pcxx_TotalNodes())) 
       {
          Message("GiveElementProc()_2D: Error in 2D Distribution object.",0);
          proc = (proc)% (pcxx_TotalNodes());
        }
        return proc;
}
int Distribution:: GiveElementProc(int i, int j, int k){

       Message("GiveElementProc()_3D: Sorry, 3D template not implemented.",1);
       return 0;
}
class  Align {
public:
public:
       int nbelement;
public:
       int nbdim;
public:
       int dim1size,dim2size,dim3size;
public:
       int ret_index1;
public:
       int ret_index2;
public:
       int ret_index3;
public:
       int chosen;
public:
         Align(int i, int j, char *str){
       
       }
public:
         Align(int n1, int n2, int choix){
       
          nbdim = 2;
          dim1size = n1;
          dim2size = n2;
          nbelement = (n1) * (n2);
          chosen = choix;
       }
public:
         Align(int n1, int choix){
       
          nbdim = 1;
          dim1size = n1;
          dim2size = 0;
          nbelement = n1;
          chosen = choix;
       }
public:
       void  align_func(int var_i, int var_j);
 
};
class  Kernel {
public:
public:
       Distribution  *Tmp;
public:
       Align  *align;
       struct INFO_HEAD GlobalInfo;
public:
       int CollectionNumber;
public:
       int CollectionNumber_Type;
public:
       int  *buffer;
public:
        Kernel(Distribution *T, Align *A, int sizelem);
public:
        Kernel(Kernel *col);
public:
        ~Kernel();
public:
       int Is_Local(int index);
public:
       int Is_Local(int index1, int index2);
public:
       int GlobalIndex(int i);
public:
       int GlobalIndex(int i, int j);
public:
       int Get_2DHighIndex(int index);
public:
       int Get_2DLowIndex(int index);
public:
       int AllocatedProc(int index);
public:
       int AllocatedProc(int index1, int index2);
public:
       int Install_Collection(Distribution *T, Align *A, int sizeelem);
public:
       int  *Get_Element(int index);
public:
       int  *Get_Element(int index1, int index2);
public:
       int  *Get_ElementPart(int index, int startof, int size);
public:
       int  *Get_ElementPart(int index1, int index2, int startof, int size);
public:
       int Get_ElementPart_Int(int index1, int startof);
public:
       float Get_ElementPart_Float(int index1, int startof);
public:
       double Get_ElementPart_Double(int index1, int startof);
public:
       int Get_ElementPart_Int(int index1, int index2, int startof);
public:
       float Get_ElementPart_Float(int index1, int index2, int startof);
public:
       double Get_ElementPart_Double(int index1, int index2, int startof);
public:
       int  *Get_CopyElem(int index);
public:
       int  *Get_CopyElem(int index1, int index2);
public:
       void  Fetch_Element(int index, int *buf, int startof, int size);
 
};
int Kernel:: AllocatedProc(int index){

       int proc = 0;
       (align)->align_func(index,0);
       if (((Tmp)->nbdim) == (1)) 
       {
          proc = (Tmp)->GiveElementProc((align)->ret_index1);
        }
        else{
          proc = (Tmp)->GiveElementProc((align)->ret_index1,(align)->ret_index2);
        }
       return proc;
}
int Kernel:: AllocatedProc(int index1, int index2){

       int proc = 0;
       (align)->align_func(index1,index2);
       proc = (Tmp)->GiveElementProc((align)->ret_index1,(align)->ret_index2);
       return proc;
}
int Kernel:: GlobalIndex(int index){

       return index;
}
int Kernel:: GlobalIndex(int index1, int index2){

       return (index1) + ((index2) * (GlobalInfo.dim1size));
}
int Kernel:: Get_2DHighIndex(int index){

       return (index) / (GlobalInfo.dim1size);
}
int Kernel:: Get_2DLowIndex(int index){

       return (index)% (GlobalInfo.dim1size);
}
int Kernel:: Is_Local(int index){

       if ((GlobalInfo.Table[GlobalIndex(index)]) == ((int *) 0)) 
       {
          return 0;
        }
        else{
          return 1;
        }
}
int Kernel:: Is_Local(int index1, int index2){

       if ((GlobalInfo.Table[GlobalIndex(index1,index2)]) == ((int *) 0)) 
       {
          return 0;
        }
        else{
          return 1;
        }
}
 Kernel:: Kernel(Distribution *T, Align *A, int sizelem){

       if (( !(T)) || ( !(A))) 
       {
          Message("Kernel(): No alignement or template provided.",1);
        }
        Tmp = T;
       align = A;
       if (((A)->nbelement) >  ((T)->nbelement)) 
       {
          Message("Kernel(): Elements in Align are more than elements in Distribution.",0);
        }
        GlobalInfo.type =  (-(1));
       GlobalInfo.number_dimension = (A)->nbdim;
       GlobalInfo.element_size = sizelem;
       GlobalInfo.nb_element = (A)->nbelement;
       GlobalInfo.dim1size = (A)->dim1size;
       GlobalInfo.dim2size = (A)->dim2size;
       GlobalInfo.dim3size = (A)->dim3size;
       if ( !(Install_Collection(T,A,sizelem))) 
       {
          Message("Kernel(): Error in creating collection.",1);
        }
        _pcxx_Barrier();
}
 Kernel:: Kernel(Kernel *col){

       Distribution  *T;
       Align  *A;
       int sizelem;
       int i;
       if ( !(col)) 
       {
          Message("Kernel(): Collection not provided.",1);
        }
        T = (col)->Tmp;
       A = (col)->align;
       sizelem = (col)->GlobalInfo.element_size;
       if (( !(T)) || ( !(A))) 
       {
          Message("Kernel(): No alignement or template provided.",1);
        }
        Tmp = T;
       align = A;
       GlobalInfo.type =  (-(1));
       GlobalInfo.number_dimension = (A)->nbdim;
       GlobalInfo.element_size = sizelem;
       GlobalInfo.nb_element = (A)->nbelement;
       GlobalInfo.dim1size = (A)->dim1size;
       GlobalInfo.dim2size = (A)->dim2size;
       GlobalInfo.dim3size = (A)->dim3size;
       if ( !(Install_Collection(T,A,sizelem))) 
       {
          Message("Kernel(): Error in creating collection.",1);
        }
        for (i = 0 ; (i) < (GlobalInfo.nb_element) ; (i)++)
       {
          if ((GlobalInfo.Table[i]) && ((col)->GlobalInfo.Table[i])) 
          {
             bcopy((char *) (col)->GlobalInfo.Table[i],(char *) GlobalInfo.Table[i],sizelem);
           }
         }
       _pcxx_Barrier();
}
void  Kernel:: Fetch_Element(int index, int *buf, int startof, int size){

       int wh,offset;
       int data1,data2,data3,data4;
       int cs;
       int  *pt;
       if ((GlobalInfo.Table[index])!=(0)) 
       {
          pt = GlobalInfo.Table[index];
        }
        else{
          pt = (int *) GlobalInfo.Where[index];
        }
       if ( !(pt)) 
       {
          Message("Element not found",0);
        }
        if (((size)!=( (-(1)))) || ((GlobalInfo.element_size)<=(16))) 
       {
          cs = size;
        }
        if ((size) == ( (-(1)))) 
       {
          cs = (GlobalInfo.element_size) / (sizeof (int) );
        }
        else{
          cs = size;
        }
       for (offset = startof ; (offset) < ((cs) + (startof)) ; offset = (offset) + (4))
       {
          buf[(offset) -(startof)] = pt[offset];
          buf[((offset) -(startof)) + (1)] = pt[(offset) + (1)];
          buf[((offset) -(startof)) + (2)] = pt[(offset) + (2)];
          buf[((offset) -(startof)) + (3)] = pt[(offset) + (3)];
        }
}
int * Kernel:: Get_Element(int index){

       int wh,offset;
       if ((GlobalInfo.number_dimension) == (2)) 
       {
          return Get_Element(Get_2DLowIndex(index),Get_2DHighIndex(index));
        }
        if (ev_class&8) 
       {
          se_event(60165,CollectionNumber);
        }
        if (ev_class&8) 
       {
          se_event(60166,GlobalIndex(index));
        }
        if (Is_Local(index)) 
       {
          if ( !(GlobalInfo.Table[GlobalIndex(index)])) 
          {
             Message("Get_Element_1D: Error in loading local element.",1);
           }
           return GlobalInfo.Table[GlobalIndex(index)];
        }
        else{
          return (int *) GlobalInfo.Where[GlobalIndex(index)];
        }
}
int * Kernel:: Get_Element(int index1, int index2){

       int wh,offset;
       if (ev_class&8) 
       {
          se_event(60165,CollectionNumber);
        }
        if (ev_class&8) 
       {
          se_event(60166,GlobalIndex(index1,index2));
        }
        if (Is_Local(index1,index2)) 
       {
          if ( !(GlobalInfo.Table[GlobalIndex(index1,index2)])) 
          {
             Message("Get_Element_2D: Error in loading local element.",1);
           }
           return GlobalInfo.Table[GlobalIndex(index1,index2)];
        }
        else{
          return (int *) GlobalInfo.Where[GlobalIndex(index1,index2)];
        }
}
int * Kernel:: Get_ElementPart(int index, int startof, int size){

       int wh,offset;
       if ((GlobalInfo.number_dimension) == (2)) 
       {
          return Get_ElementPart(Get_2DLowIndex(index),Get_2DHighIndex(index),startof,size);
        }
        if (ev_class&8) 
       {
          se_event(60165,CollectionNumber);
        }
        if (ev_class&8) 
       {
          se_event(60166,GlobalIndex(index));
        }
        if (Is_Local(index)) 
       {
          if ( !(GlobalInfo.Table[GlobalIndex(index)])) 
          {
             Message("Get_ElementPart_1D: Error in loading local element.",1);
           }
           return (GlobalInfo.Table[GlobalIndex(index)]) + (startof);
        }
        else{
          return ((int *) GlobalInfo.Where[GlobalIndex(index)]) + (startof);
        }
}
int * Kernel:: Get_ElementPart(int index1, int index2, int startof, int size){

       int wh,offset;
       if (ev_class&8) 
       {
          se_event(60165,CollectionNumber);
        }
        if (ev_class&8) 
       {
          se_event(60166,GlobalIndex(index1,index2));
        }
        if (Is_Local(index1,index2)) 
       {
          if ( !(GlobalInfo.Table[GlobalIndex(index1,index2)])) 
          {
             Message("Get_ElementPart_2D: Error in loading local element.",1);
           }
           return (GlobalInfo.Table[GlobalIndex(index1,index2)]) + (startof);
        }
        else{
          return ((int *) GlobalInfo.Where[GlobalIndex(index1,index2)]) + (startof);
        }
}
int Kernel:: Get_ElementPart_Int(int index, int startof){

       int wh,offset;
       if (ev_class&8) 
       {
          se_event(60165,CollectionNumber);
        }
        if (ev_class&8) 
       {
          se_event(60166,GlobalIndex(index));
        }
        if (Is_Local(index)) 
       {
          if ( !(GlobalInfo.Table[GlobalIndex(index)])) 
          {
             Message("Get_ElementPart_Int_1D: Error in loading local element.",1);
           }
           return (int) *((int *) (GlobalInfo.Table[GlobalIndex(index)]) + (startof));
        }
        else{
          return (int) *((int *) (GlobalInfo.Where[GlobalIndex(index)]) + (startof));
        }
}
float Kernel:: Get_ElementPart_Float(int index, int startof){

       int wh,offset;
       if (ev_class&8) 
       {
          se_event(60165,CollectionNumber);
        }
        if (ev_class&8) 
       {
          se_event(60166,GlobalIndex(index));
        }
        if (Is_Local(index)) 
       {
          if ( !(GlobalInfo.Table[GlobalIndex(index)])) 
          {
             Message("Get_ElementPart_Float_1D: Error in loading local element.",1);
           }
           return (float) *((float *) (GlobalInfo.Table[GlobalIndex(index)]) + (startof));
        }
        else{
          return (float) *((float *) (GlobalInfo.Where[GlobalIndex(index)]) + (startof));
        }
}
double Kernel:: Get_ElementPart_Double(int index, int startof){

       int wh,offset;
       if (ev_class&8) 
       {
          se_event(60165,CollectionNumber);
        }
        if (ev_class&8) 
       {
          se_event(60166,GlobalIndex(index));
        }
        if (Is_Local(index)) 
       {
          if ( !(GlobalInfo.Table[GlobalIndex(index)])) 
          {
             Message("Get_ElementPart_Double_1D: Error in loading local element.",1);
           }
           return (double) *((double *) (GlobalInfo.Table[GlobalIndex(index)]) + (startof));
        }
        else{
          return (double) *((double *) (GlobalInfo.Where[GlobalIndex(index)]) + (startof));
        }
}
int Kernel:: Get_ElementPart_Int(int index1, int index2, int startof){

       int wh,offset;
       if (ev_class&8) 
       {
          se_event(60165,CollectionNumber);
        }
        if (ev_class&8) 
       {
          se_event(60166,GlobalIndex(index1,index2));
        }
        if (Is_Local(index1,index2)) 
       {
          if ( !(GlobalInfo.Table[GlobalIndex(index1,index2)])) 
          {
             Message("Get_ElementPart_Int_2D: Error in loading local element.",1);
           }
           return (int) *((int *) (GlobalInfo.Table[GlobalIndex(index1,index2)]) + (startof));
        }
        else{
          return (int) *((int *) (GlobalInfo.Where[GlobalIndex(index1,index2)]) + (startof));
        }
}
float Kernel:: Get_ElementPart_Float(int index1, int index2, int startof){

       int wh,offset;
       if (ev_class&8) 
       {
          se_event(60165,CollectionNumber);
        }
        if (ev_class&8) 
       {
          se_event(60166,GlobalIndex(index1,index2));
        }
        if (Is_Local(index1,index2)) 
       {
          if ( !(GlobalInfo.Table[GlobalIndex(index1,index2)])) 
          {
             Message("Get_ElementPart_Float_2D: Error in loading local element.",1);
           }
           return (float) *((float *) (GlobalInfo.Table[GlobalIndex(index1,index2)]) + (startof));
        }
        else{
          return (float) *((float *) (GlobalInfo.Where[GlobalIndex(index1,index2)]) + (startof));
        }
}
double Kernel:: Get_ElementPart_Double(int index1, int index2, int startof){

       int wh,offset;
       if (ev_class&8) 
       {
          se_event(60165,CollectionNumber);
        }
        if (ev_class&8) 
       {
          se_event(60166,GlobalIndex(index1,index2));
        }
        if (Is_Local(index1,index2)) 
       {
          if ( !(GlobalInfo.Table[GlobalIndex(index1,index2)])) 
          {
             Message("Get_ElementPart_Double_2D: Error in loading local element.",1);
           }
           return (double) *((double *) (GlobalInfo.Table[GlobalIndex(index1,index2)]) + (startof));
        }
        else{
          return (double) *((double *) (GlobalInfo.Where[GlobalIndex(index1,index2)]) + (startof));
        }
}
int * Kernel:: Get_CopyElem(int index){

       int wh,offset;
       int  *NBuf;
       if ((GlobalInfo.number_dimension) == (2)) 
       {
          return Get_CopyElem(Get_2DLowIndex(index),Get_2DHighIndex(index));
        }
        if (ev_class&8) 
       {
          se_event(60165,CollectionNumber);
        }
        if (ev_class&8) 
       {
          se_event(60166,GlobalIndex(index));
        }
        if (Is_Local(index)) 
       {
          if ( !(GlobalInfo.Table[GlobalIndex(index)])) 
          {
             Message("Get_CopyElem_1D: Error in loading local element.",1);
           }
           return GlobalInfo.Table[GlobalIndex(index)];
        }
        NBuf = new int [((GlobalInfo.element_size) / (sizeof(int ))) + (4)] ;
       Fetch_Element(GlobalIndex(index),NBuf,0, (-(1)));
       return NBuf;
}
int * Kernel:: Get_CopyElem(int index1, int index2){

       int wh,offset;
       int  *NBuf;
       if (ev_class&8) 
       {
          se_event(60165,CollectionNumber);
        }
        if (ev_class&8) 
       {
          se_event(60166,GlobalIndex(index1,index2));
        }
        if (Is_Local(index1,index2)) 
       {
          if ( !(GlobalInfo.Table[GlobalIndex(index1,index2)])) 
          {
             Message("Get_CopyElem_2D: Error in loading local element",1);
           }
           return GlobalInfo.Table[GlobalIndex(index1,index2)];
        }
        NBuf = new int [((GlobalInfo.element_size) / (sizeof(int ))) + (4)] ;
       Fetch_Element(GlobalIndex(index1,index2),NBuf,0, (-(1)));
       return NBuf;
}
int Kernel:: Install_Collection(Distribution *T, Align *A, int sizeelem){

       int i,j;
       int proc;
       int count;
       int  *allocated;
       int  **ElemAllocVector;
       CollectionNumber = GetNumberOfCollection();
       IncNumberOfCollection();
       if (ev_class&8) 
       {
          se_event(60150,CollectionNumber);
        }
        if (ev_class&8) 
       {
          se_event(60151,GlobalInfo.number_dimension);
        }
        if (ev_class&8) 
       {
          se_event(60152,GlobalInfo.element_size);
        }
        if (ev_class&8) 
       {
          se_event(60153,GlobalInfo.nb_element);
        }
        if (ev_class&8) 
       {
          se_event(60154,GlobalInfo.dim1size);
        }
        if (ev_class&8) 
       {
          se_event(60155,GlobalInfo.dim2size);
        }
        GlobalInfo.Table = (int **) malloc(((A)->nbelement) * (sizeof (int *) ));
       if ((GlobalInfo.Table) == (0)) 
       {
          Message("Install_Collection: unable to allocate space.",1);
        }
        GlobalInfo.Where = (int **) malloc(((A)->nbelement) * (sizeof (int *) ));
       if ((GlobalInfo.Where) == (0)) 
       {
          Message("Install_Collection : unable to allocate space",1);
        }
        SetTableOfCollection(CollectionNumber,(char *) &(GlobalInfo));
       buffer = new int [((sizeelem) / (sizeof(int ))) + (4)] ;
       if (((A)->nbelement) == (0)) 
       {
          Message("No Element in the collection",1);
        }
        count = 0;
       if ((GlobalInfo.number_dimension) == (1)) 
       {
          for (i = 0 ; (i) < (GlobalInfo.dim1size) ; (i)++)
          {
             if ((AllocatedProc(i)) == (pcxx_NodeNumber())) 
             {
                (count)++;
              }
            }
        }
        else{
          if ((GlobalInfo.number_dimension) == (2)) 
          {
             for (i = 0 ; (i) < (GlobalInfo.dim1size) ; (i)++)
             {
                for (j = 0 ; (j) < (GlobalInfo.dim2size) ; (j)++)
                {
                   if ((AllocatedProc(i,j)) == (pcxx_NodeNumber())) 
                   {
                      (count)++;
                    }
                  }
              }
           }
           else{
             if ((GlobalInfo.number_dimension) >  (2)) 
             {
                Message("Install_Collection(): 3D implementation not available.",1);
              }
            }
        }
       AweAllocElemSpace(pcxx_NodeNumber(),(count) * ((sizeelem) + ((4) * (sizeof (int) ))));
       _pcxx_Barrier();
       ElemAllocVector = (int **) malloc((pcxx_TotalNodes()) * (sizeof (int *) ));
       for (i = 0 ; (i) < (pcxx_TotalNodes()) ; (i)++)
       {
          ElemAllocVector[i] = (int *) AweGetElemSpacePtr(i);
        }
       if ((GlobalInfo.number_dimension) == (1)) 
       {
          for (i = 0 ; (i) < (GlobalInfo.dim1size) ; (i)++)
          {
             proc = AllocatedProc(i);
             allocated = ElemAllocVector[proc];
             ElemAllocVector[proc] += ((sizeelem) / (sizeof (int) )) + (4);
             if ((proc) == (pcxx_NodeNumber())) 
             {
                GlobalInfo.Table[GlobalIndex(i)] = allocated;
                GlobalInfo.Where[GlobalIndex(i)] = (int *) 0;
                if (ev_class&8) 
                {
                   se_event(60160,GlobalIndex(i));
                 }
               }
              else{
                GlobalInfo.Table[GlobalIndex(i)] = (int *) 0;
                GlobalInfo.Where[GlobalIndex(i)] = allocated;
              }
           }
        }
        else{
          if ((GlobalInfo.number_dimension) == (2)) 
          {
             for (i = 0 ; (i) < (GlobalInfo.dim1size) ; (i)++)
             {
                for (j = 0 ; (j) < (GlobalInfo.dim2size) ; (j)++)
                {
                   proc = AllocatedProc(i,j);
                   allocated = ElemAllocVector[proc];
                   ElemAllocVector[proc] += ((sizeelem) / (sizeof (int) )) + (4);
                   if ((proc) == (pcxx_NodeNumber())) 
                   {
                      GlobalInfo.Table[GlobalIndex(i,j)] = allocated;
                      GlobalInfo.Where[GlobalIndex(i,j)] = (int *) 0;
                      if (ev_class&8) 
                      {
                         se_event(60160,GlobalIndex(i,j));
                       }
                     }
                    else{
                      GlobalInfo.Table[GlobalIndex(i,j)] = (int *) 0;
                      GlobalInfo.Where[GlobalIndex(i,j)] = allocated;
                    }
                 }
              }
           }
         }
       free(ElemAllocVector);
       _pcxx_Barrier();
       return 1;
}
 Kernel:: ~Kernel(){

       int found;
       int i,j;
       SetTableOfCollection(CollectionNumber,(char *) 0);
       delete  buffer;
       if ((GlobalInfo.number_dimension) == (1)) 
       {
          for (i = 0 ; (i) < (GlobalInfo.dim1size) ; (i)++)
          {
             if ((GlobalInfo.Table[GlobalIndex(i)])!=(0)) 
             {
                AweDealloc(GlobalInfo.Table[GlobalIndex(i)]);
                break;
              }
            }
        }
        else{
          if ((GlobalInfo.number_dimension) == (2)) 
          {
             found = 0;
             for (i = 0 ; ((i) < (GlobalInfo.dim1size)) && ( !(found)) ; (i)++)
             {
                for (j = 0 ; (j) < (GlobalInfo.dim2size) ; (j)++)
                {
                   if ((GlobalInfo.Table[GlobalIndex(i,j)])!=(0)) 
                   {
                      AweDealloc(GlobalInfo.Table[GlobalIndex(i,j)]);
                      found = 1;
                      break;
                    }
                  }
              }
           }
         }
       _pcxx_Barrier();
       free(GlobalInfo.Where);
       free(GlobalInfo.Table);
}
int  GetFirstLocalElementIndex(Kernel *p){

       Kernel  *pt;
       int i;
       pt = (Kernel *) p;
       for (i = 0 ; (i) < ((pt)->GlobalInfo.nb_element) ; (i)++)
       {
          if (((pt)->GlobalInfo.Table[i])!=(0)) 
          {
             return i;
           }
         }
       return  (-(1));
}
void   ResetLocal(Kernel *p){

       (p)->GlobalInfo.LocalTraversalCount = 0;
       SetNextCollectionTraversalLevel((char *) p);
}
int  Local(int elem){

       Kernel  *pt;
       int i;
       pt = (Kernel *) GetCollectionTraversalLevel();
       if (((pt)->GlobalInfo.LocalTraversalCount) >  ((pt)->GlobalInfo.nb_element)) 
       {
          DecCollectionTraversalLevel();
          return  (-(1));
        }
        for (i = (pt)->GlobalInfo.LocalTraversalCount ; (i) < ((pt)->GlobalInfo.nb_element) ; (i)++)
       {
          if (((pt)->GlobalInfo.Table[i])!=(0)) 
          {
             (pt)->GlobalInfo.LocalTraversalCount = (i) + (1);
             return i;
           }
         }
       DecCollectionTraversalLevel();
       return  (-(1));
}
int  FirstLocal(){

       return Local(0);
}
int  FirstInSubset(Kernel *coll, int lb, int ub, int step){

       if ( !(coll)) 
       {
          return  (-(1));
        }
        if ((lb) == ( (-(1)))) 
       {
          return 0;
        }
        if ((lb)<=(ub)) 
       {
          return lb;
        }
        return  (-(1));
}
int  NextInSubset(Kernel *coll, int lb, int ub, int step, int var){

       int bsup;
       if ( !(coll)) 
       {
          return  (-(1));
        }
        if ((ub) == ( (-(1)))) 
       {
          bsup = (coll)->GlobalInfo.dim1size;
        }
        else{
          bsup = ub;
        }
       if (((var) + (step))<=(bsup)) 
       {
          return (var) + (step);
        }
        else{
          return  (-(1));
        }
}
  CheckLocal(Kernel *coll, int index){

       if ( !(coll)) 
       {
          return 0;
        }
        return (coll)->Is_Local(index);
}
class  SuperKernel__Vector: public Kernel {
public:
       int dim1size;
       int dim2size;
        SuperKernel__Vector(Distribution *T, Align *A);
       Vector  *operator ()(int i1);
       Vector  *operator ()(int i1, int i2);
 
};
Vector * SuperKernel__Vector:: operator ()(int i1){

       Vector  *pt;
       pt = (Vector *) Get_Element(i1);
       return pt;
}
Vector * SuperKernel__Vector:: operator ()(int i1, int i2){

       Vector  *pt;
       pt = (Vector *) Get_Element(i1,i2);
       return pt;
}
 SuperKernel__Vector:: SuperKernel__Vector(Distribution *T, Align *A):Kernel(T,A,sizeof (Vector) ){

       int i,j;
       if (( !(T)) || ( !(A))) 
       {
          Message("No alignment or template for collection initialization.",1);
        }
        dim1size = (A)->dim1size;
       dim2size = (A)->dim2size;
       if (((A)->nbdim) == (1)) 
       {
          for (i = 0 ; (i) < (dim1size) ; (i)++)
          {
             if (Is_Local(i)) 
             {
                ((*(this ))(i))->index1 = i;
                ((*(this ))(i))->index2 = 0;
                ((*(this ))(i))->ThisCollection = (SuperKernel__Vector *) this ;
                ((*(this ))(i))->Ident = (((this )->CollectionNumber) * (16777216)) + (i);
              }
            }
          _pcxx_Barrier();
        }
        if (((A)->nbdim) == (2)) 
       {
          for (i = 0 ; (i) < (dim1size) ; (i)++)
          {
             for (j = 0 ; (j) < (dim2size) ; (j)++)
             {
                if (Is_Local(i,j)) 
                {
                   ((*(this ))(i,j))->index1 = i;
                   ((*(this ))(i,j))->index2 = j;
                   ((*(this ))(i,j))->ThisCollection = (SuperKernel__Vector *) this ;
                   ((*(this ))(i))->Ident = ((((this )->CollectionNumber) * (16777216)) + (i)) + ((j) * ((this )->dim1size));
                 }
               }
           }
          _pcxx_Barrier();
        }
        if (((A)->nbdim)>=(3)) 
       {
          Message("3D and higher-dimensional collection not implemented.",1);
        }
 }
Vector * Vector:: Self(int i){

       return (Vector *) (ThisCollection)->Get_Element((index1) + (i));
}
Vector * Vector:: Self(int i, int j){

       return (Vector *) (ThisCollection)->Get_Element((index1) + (i),(index2) + (j));
}
class  DistributedArray__Vector: public SuperKernel__Vector {
public:
       int blocksize;
        DistributedArray__Vector(Distribution *T, Align *A);
        DistributedArray__Vector(Kernel *coll);
       void  Assign(int i1, Vector &e);
       void  Assign(int i1, int i2, Vector &e);
       DistributedArray__Vector  &operator =(DistributedArray__Vector &rhs);
       void  Shift(int dim, int distance);
       void  Reduce();
       void  ReduceDim1();
       void  ReduceDim2();
       void  Broadcast();
       void  BroadcastDim1();
       void  BroadcastDim2();
       double DotProd(DistributedArray__Vector &arg1);
 
};
 DistributedArray__Vector:: DistributedArray__Vector(Distribution *T, Align *A):SuperKernel__Vector(T,A){

       if (( !(T)) || ( !(A))) 
       {
          Message("No alignment or template for collection initialization.",1);
        }
        blocksize = 0;
       ResetLocal(this );
       for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
       {
          pcxx_Poll();
          ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->Set_ThisCollection(this );
        }
       _pcxx_Barrier();
       if (((A)->nbdim)>=(3)) 
       {
          Message("3D and higher-dimensional DistributedArray not implemented.",1);
        }
 }
void  DistributedArray__Vector:: Shift(int dim, int distance){

       ResetLocal(this );
       for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
       {
          pcxx_Poll();
          ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->LocalShiftStep1(dim,distance);
        }
       _pcxx_Barrier();
       ResetLocal(this );
       for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
       {
          pcxx_Poll();
          ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->LocalShiftStep2();
        }
       _pcxx_Barrier();
       ResetLocal(this );
       for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
       {
          pcxx_Poll();
          ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->DeleteTemp();
        }
       _pcxx_Barrier();
}
void  Vector:: LocalShiftStep1(int dim, int distance){

       int elem;
       Vector  *pt;
       double  *ptc,*pte;
       int i,size;
       if ((dim) == (1)) 
       {
          elem = (index1) + (distance);
          if ((elem)>=(0)) 
          {
             elem = (elem)% ((ThisCollection)->dim1size);
           }
           else{
             while ((elem) < (0))
             {
                elem = (elem) + ((ThisCollection)->dim1size);
              }
           }
          if ((ThisCollection)->Is_Local(elem,index2)) 
          {
             pt = (Vector *) (ThisCollection)->Get_Element(elem,index2);
             size = ((ThisCollection)->GlobalInfo.element_size) / (sizeof (double) );
             (this )->temporaryelement = (Vector *) new double [(size) + (1)] ;
             ptc = (double *) (this )->temporaryelement;
             pte = (double *) pt;
             for (i = 0 ; (i)<=(size) ; (i)++)
             {
                *((ptc)++) = *((pte)++);
              }
           }
           else{
             (this )->temporaryelement = (Vector *) (ThisCollection)->Get_CopyElem(elem,index2);
           }
        }
        else{
          elem = (index2) + (distance);
          if ((elem)>=(0)) 
          {
             elem = (elem)% ((ThisCollection)->dim2size);
           }
           else{
             while ((elem) < (0))
             {
                elem = (elem) + ((ThisCollection)->dim2size);
              }
           }
          if ((ThisCollection)->Is_Local(index1,elem)) 
          {
             pt = (Vector *) (ThisCollection)->Get_Element(index1,elem);
             size = ((ThisCollection)->GlobalInfo.element_size) / (sizeof (double) );
             (this )->temporaryelement = (Vector *) new double [(size) + (1)] ;
             ptc = (double *) (this )->temporaryelement;
             pte = (double *) pt;
             for (i = 0 ; (i)<=(size) ; (i)++)
             {
                *((ptc)++) = *((pte)++);
              }
           }
           else{
             (this )->temporaryelement = (Vector *) (ThisCollection)->Get_CopyElem(index1,elem);
           }
        }
}
void  Vector:: LocalShiftStep2(){

       *(this ) = *((this )->temporaryelement);
}
void  Vector:: DeleteTemp(){

       delete  (this )->temporaryelement;
       (this )->temporaryelement = 0;
}
void  Vector:: Set_ThisCollection(DistributedArray__Vector *C){

       (this )->ThisCollection = C;
}
void  Vector:: WhereAmI(){

       printf("Element (%d, %d) on processor %d\n",index1,index2,pcxx_NodeNumber());
       _pcxx_Barrier();
}
void  DistributedArray__Vector:: Assign(int i1, Vector &e){

       if ((this )->Is_Local(i1)) 
       {
          *((*(this ))(i1)) = e;
        }
 }
void  DistributedArray__Vector:: Assign(int i1, int i2, Vector &e){

       if ((this )->Is_Local(i1,i2)) 
       {
          *((*(this ))(i1,i2)) = e;
        }
 }
void  DistributedArray__Vector:: Reduce(){

       int steps = 1;
       int borne;
       if (dim2size) 
       {
          borne = (dim1size) * (dim2size);
        }
        else{
          borne = dim1size;
        }
       while ((steps) < (borne))
       {
          ResetLocal(this );
          for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
          {
             pcxx_Poll();
             ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->LocalReduce(this ,steps);
           }
          _pcxx_Barrier();
          steps = (steps) * (2);
        }
}
void  DistributedArray__Vector:: ReduceDim1(){

       int steps = 1;
       while ((steps) < (dim1size))
       {
          ResetLocal(this );
          for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
          {
             pcxx_Poll();
             ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->LocalReduceDim1(this ,steps);
           }
          _pcxx_Barrier();
          steps = (steps) * (2);
        }
}
void  DistributedArray__Vector:: ReduceDim2(){

       int steps = 1;
       while ((steps) < (dim2size))
       {
          ResetLocal(this );
          for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
          {
             pcxx_Poll();
             ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->LocalReduceDim2(this ,steps);
           }
          _pcxx_Barrier();
          steps = (steps) * (2);
        }
}
void  Vector:: LocalReduce(DistributedArray__Vector *array, int step){

       int ind;
       ind = (ThisCollection)->GlobalIndex(index1,index2);
       if (((ind)% ((2) * (step))) == (0)) 
       {
          *(this ) += *((*(array))((ind) + (step)));
        }
 }
void  Vector:: LocalReduceDim1(DistributedArray__Vector *array, int step){

       if (((index1)% ((2) * (step))) == (0)) 
       {
          *(this ) += *((*(array))((index1) + (step),index2));
        }
 }
void  Vector:: LocalReduceDim2(DistributedArray__Vector *array, int step){

       if (((index2)% ((2) * (step))) == (0)) 
       {
          *(this ) += *((*(array))(index1,(index2) + (step)));
        }
 }
void  DistributedArray__Vector:: Broadcast(){

       int steps;
       if (dim2size) 
       {
          steps = ((dim1size) * (dim2size)) / (2);
        }
        else{
          steps = (dim1size) / (2);
        }
       while (steps)
       {
          ResetLocal(this );
          for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
          {
             pcxx_Poll();
             ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->LocalBroadcast(this ,steps);
           }
          _pcxx_Barrier();
          if ((steps) == (1)) 
          {
             break;
           }
           steps = (steps) / (2);
        }
}
void  DistributedArray__Vector:: BroadcastDim1(){

       int steps = (dim1size) / (2);
       while (steps)
       {
          ResetLocal(this );
          for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
          {
             pcxx_Poll();
             ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->LocalBroadcastDim1(this ,steps);
           }
          _pcxx_Barrier();
          if ((steps) == (1)) 
          {
             break;
           }
           steps = (steps) / (2);
        }
}
void  DistributedArray__Vector:: BroadcastDim2(){

       int steps = (dim2size) / (2);
       while (steps)
       {
          ResetLocal(this );
          for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
          {
             pcxx_Poll();
             ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->LocalBroadcastDim2(this ,steps);
           }
          _pcxx_Barrier();
          if ((steps) == (1)) 
          {
             break;
           }
           steps = (steps) / (2);
        }
}
void  Vector:: LocalBroadcast(DistributedArray__Vector *array, int step){

       int ind;
       ind = (ThisCollection)->GlobalIndex(index1,index2);
       if (((ind) && (((ind)% (step)) == (0))) && ( !(((ind)% ((2) * (step))) == (0)))) 
       {
          *(this ) = *((*(array))((ind) -(step)));
        }
 }
void  Vector:: LocalBroadcastDim1(DistributedArray__Vector *array, int step){

       if (((index1) && (((index1)% (step)) == (0))) && ( !(((index1)% ((2) * (step))) == (0)))) 
       {
          *(this ) = *((*(array))((index1) -(step),index2));
        }
 }
void  Vector:: LocalBroadcastDim2(DistributedArray__Vector *array, int step){

       if (((index2) && (((index2)% (step)) == (0))) && ( !(((index2)% ((2) * (step))) == (0)))) 
       {
          *(this ) = *((*(array))(index1,(index2) -(step)));
        }
 }
DistributedArray__Vector & DistributedArray__Vector:: operator =(DistributedArray__Vector &rhs){

       ResetLocal(this );
       for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
       {
          pcxx_Poll();
          ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->LocalCopy(&(rhs));
        }
       _pcxx_Barrier();
       return *(this );
}
void  Vector:: LocalCopy(DistributedArray__Vector *array){

       *(this ) = *((*(array))(index1,index2));
}
double DistributedArray__Vector:: DotProd(DistributedArray__Vector &arg1){

       double total;
       int steps = 1;
       int locali;
       Vector dummy;
       int  *addr1,*addr2;
       int borne;
       double  *tmp;
       ResetLocal(this );
       for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
       {
          pcxx_Poll();
          ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->ResetDotProd(arg1);
        }
       _pcxx_Barrier();
       borne = dim1size;
       if (dim2size) 
       {
          borne = (borne) * (dim2size);
        }
        while ((steps) < (borne))
       {
          ResetLocal(this );
          for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
          {
             pcxx_Poll();
             ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->LocalGSum(*(this ),steps);
           }
          _pcxx_Barrier();
          steps = (steps) * (2);
        }
       if (dim2size) 
       {
          steps = ((dim1size) * (dim2size)) / (2);
        }
        else{
          steps = (dim1size) / (2);
        }
       while (steps)
       {
          ResetLocal(this );
          for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
          {
             pcxx_Poll();
             ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->BroadcastTemp(*(this ),steps);
           }
          _pcxx_Barrier();
          if ((steps) == (1)) 
          {
             break;
           }
           steps = (steps) / (2);
        }
       locali = GetFirstLocalElementIndex(this );
       if ((locali)>=(0)) 
       {
          total = ((*(this ))(locali))->dotprodtemp;
        }
        else{
          addr1 = (int *) &(dummy);
          addr2 = (int *) &(dummy.dotprodtemp);
          tmp = (double *) (this )->Get_ElementPart((pcxx_NodeNumber())% ((this )->dim1size),(addr2) -(addr1),(sizeof (double) ) / (sizeof (int) ));
          total = *(tmp);
        }
       _pcxx_Barrier();
       return total;
}
void  Vector:: LocalGSum(DistributedArray__Vector &array, int step){

       int ind;
       ind = (ThisCollection)->GlobalIndex(index1,index2);
       if (((ind)% ((2) * (step))) == (0)) 
       {
          int  *addr1,*addr2;
          double  *tmp;
          Vector  *x;
          addr1 = (int *) this ;
          addr2 = (int *) &((this )->dotprodtemp);
          tmp = (double *) array.Get_ElementPart((ind) + (step),(addr2) -(addr1),(sizeof (double) ) / (sizeof (int) ));
          dotprodtemp += *(tmp);
        }
 }
void  Vector:: BroadcastTemp(DistributedArray__Vector &array, int step){

       int ind;
       ind = (ThisCollection)->GlobalIndex(index1,index2);
       if (((ind) && (((ind)% (step)) == (0))) && ( !(((ind)% ((2) * (step))) == (0)))) 
       {
          int  *addr1,*addr2;
          double  *tmp;
          Vector  *x;
          addr1 = (int *) this ;
          addr2 = (int *) &((this )->dotprodtemp);
          tmp = (double *) array.Get_ElementPart((ind) -(step),(addr2) -(addr1),(sizeof (double) ) / (sizeof (int) ));
          (this )->dotprodtemp = *(tmp);
        }
 }
void  Vector:: ResetDotProd(DistributedArray__Vector &arg1){

       dotprodtemp = (this )->Dot(*((arg1)(index1,index2)));
}
class  DistVector__Vector: public DistributedArray__Vector {
public:
        DistVector__Vector(Distribution *T, Align *A, int size);
       void  operator =(DistVector__Vector &rhs);
       void  Copy(DistVector__Vector *rhs);
 
};
 DistVector__Vector:: DistVector__Vector(Distribution *T, Align *A, int blksize):DistributedArray__Vector(T,A){

       int j;
       blocksize = blksize;
       ResetLocal(this );
       for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
       {
          pcxx_Poll();
          ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->allocData(blocksize);
        }
       _pcxx_Barrier();
       for (j = 0 ; (j) < (dim1size) ; (j)++)
       {
          if ((this )->Is_Local(j)) 
          {
             ((*(this ))(j))->index1 = j;
           }
         }
       _pcxx_Barrier();
}
void  Vector:: DoSubSetForward(int start, int end, int step, int s, DistVector__Vector &coll){

       if ((((index1)<=(end)) && ((index1)>=(start))) && ((((index1) -(start))% (step)) == (0))) 
       {
          if ( !(coll.Is_Local(index1))) 
          {
             Message("DoSubSetForward Bad Alignement",1);
           }
           ForwardElim(s,(coll)(index1));
        }
 }
void  Vector:: DoSubSetBackward(int start, int end, int step, int s, DistVector__Vector &coll){

       if ((((index1)<=(end)) && ((index1)>=(start))) && ((((index1) -(start))% (step)) == (0))) 
       {
          if ( !(coll.Is_Local(index1))) 
          {
             Message("DoSubSetBackward Bad Alignement",1);
           }
           BackSolve(s,(coll)(index1));
        }
 }
void  Vector:: ParBackSolve(int s, DistVector__Vector &coll){

       if ( !(coll.Is_Local(index1))) 
       {
          Message("ParBackSolve Bad Alignement",1);
        }
        BackSolve(s,(coll)(index1));
}
void  Vector:: ParForwardElim(int s, DistVector__Vector &coll){

       if ( !(coll.Is_Local(index1))) 
       {
          Message("ParForwardElim Bad Alignement",1);
        }
        ForwardElim(s,(coll)(index1));
}
void  Vector:: ParSinTransform(float **wr, float **wi, int *p, DistVector__Vector &coll){

       if ( !(coll.Is_Local(index1))) 
       {
          printf("The index1 is %d ",index1);
          Message("ParSinTransform Bad Alignement",1);
        }
        SinTransform(wr,wi,p,(coll)(index1));
}
void  Vector:: ParVector_copy(DistVector__Vector &coll){

       if ( !(coll.Is_Local(index1))) 
       {
          Message("ParVector_copy Bad Alignement",1);
        }
        Vector_copy((coll)(index1));
}
void  Vector:: BackSolve(int s, Vector *result){

       int k;
       float  *a,*b;
       Vector  *v1,*v2;
       a = (this )->tmp1;
       b = (result)->tmp1;
       pcxx_Poll();
       v1 = (Vector *) (ThisCollection)->Get_CopyElem((index1) -(s));
       v2 = (Vector *) (ThisCollection)->Get_CopyElem((index1) + (s));
       for (k = 1 ; (k) < (n) ; (k)++)
       {
          vals[k] = ((vals[k]) -((b[k]) * (((v1)->vals[k]) + ((v2)->vals[k])))) / (a[k]);
        }
       if ( !((ThisCollection)->Is_Local((index1) -(s)))) 
       {
          delete  v1;
        }
        if ( !((ThisCollection)->Is_Local((index1) + (s)))) 
       {
          delete  v2;
        }
 }
void  Vector:: ForwardElim(int s, Vector *result){

       int k;
       float  *a,*b;
       double c,gamma;
       float ar,br;
       Vector  *v1,*v2;
       a = (this )->tmp1;
       b = (result)->tmp1;
       if ((s) == (0)) 
       {
          for (k = 1 ; (k) < (n) ; (k)++)
          {
             br =  (-(1.0));
             gamma = ((3.14159265358979323846e0) * (k)) / (n);
             ar = (4.0) -((2.0) * ((float) cos(gamma)));
             a[k] = ar;
             b[k] = br;
           }
          if (((index1) == (0)) || ((index1) == (n))) 
          {
             for (k = 0 ; (k) < ((n) + (1)) ; (k)++)
             {
                vals[k] = 0.0;
              }
           }
           return ;
        }
        v1 = (Vector *) (ThisCollection)->Get_CopyElem((index1) -(s));
       v2 = (Vector *) (ThisCollection)->Get_CopyElem((index1) + (s));
       for (k = 1 ; (k) < (n) ; (k)++)
       {
          c = (b[k]) / (a[k]);
          a[k] = (a[k]) -(((c) * (2)) * (b[k]));
          b[k] = ( (-(c))) * (b[k]);
          vals[k] = (vals[k]) -((c) * (((v1)->vals[k]) + ((v2)->vals[k])));
        }
       if ( !((ThisCollection)->Is_Local((index1) -(s)))) 
       {
          delete  v1;
        }
        if ( !((ThisCollection)->Is_Local((index1) + (s)))) 
       {
          delete  v2;
        }
 }
void   transbody(int n, int base, int m, Vector *u){

       int i;
       Vector x,y;
       int j,k;
       k = (base) + (m);
       x.resize((n) + (1));
       y.resize((n) + (1));
       x.put(0.0,n);
       y.put(0.0,n);
       for (i = base ; (i) < (k) ; (i)++)
       {
          double gamma;
          float a,b;
          b =  (-(1.0));
          gamma = ((3.14159265358979323846e0) * (i)) / (n);
          a = (4.0) -((2.0) * ((float) cos(gamma)));
          for (j = 0 ; (j) < (n) ; (j)++)
          {
             x.put(u[j].get(i),j);
           }
          x.put(0.0,0);
          x.SolveTridiag(a,b,&(y));
          for (j = 0 ; (j) < (n) ; (j)++)
          {
             u[j].put(y.get(j),i);
           }
        }
}
typedef  float  *floatptr;
void   CyclicReduction(int n, Vector *y){

       int i,k,s;
       double gamma;
       float ar,br,t;
       float  **a,**b;
       double c;
       a = new floatptr [(n) + (1)] ;
       b = new floatptr [(n) + (1)] ;
       for (i = 0 ; (i) < ((n) + (1)) ; (i)++)
       {
          a[i] = new float [(n) + (1)] ;
          b[i] = new float [(n) + (1)] ;
        }
       for (k = 1 ; (k) < (n) ; (k)++)
       {
          br =  (-(1.0));
          gamma = ((3.14159265358979323846e0) * (k)) / (n);
          ar = (4.0) -((2.0) * (cos(gamma)));
          for (i = 1 ; (i) < (n) ; (i)++)
          {
             a[i][k] = ar;
             b[i][k] = br;
           }
        }
       for (s = 1 ; (s) < ((n) / (2)) ; s = (2) * (s))
       {
          for (i = (2) * (s) ; (i) < (n) ; i = (i) + ((2) * (s)))
          {
             for (k = 1 ; (k) < (n) ; (k)++)
             {
                c = (b[i][k]) / (a[i][k]);
                a[i][k] = (a[i][k]) -(((c) * (2)) * (b[i][k]));
                b[i][k] = ( (-(c))) * (b[i][k]);
                t = (y[i].get(k)) -((c) * ((y[(i) -(s)].get(k)) + (y[(i) + (s)].get(k))));
                y[i].put(t,k);
              }
           }
        }
       for (k = 0 ; (k) < ((n) + (1)) ; (k)++)
       {
          y[0].put(0.0,k);
          y[n].put(0.0,k);
        }
       for (s = (n) / (2) ; (s)>=(1) ; s = (s) / (2))
       {
          for (i = s ; (i) < (n) ; i = (i) + ((2) * (s)))
          {
             for (k = 1 ; (k) < (n) ; (k)++)
             {
                t = ((y[i].get(k)) -((b[i][k]) * ((y[(i) -(s)].get(k)) + (y[(i) + (s)].get(k))))) / (a[i][k]);
                y[i].put(t,k);
              }
           }
        }
}
void   print_grid(Vector *f, int n){

       int i,j;
       for (i = 0 ; (i)<=(n) ; (i)++)
       {
          for (j = 0 ; (j)<=(n) ; (j)++)
          {
             printf(" %6.3f",f[i].get(j));
           }
          printf("\n");
        }
       printf("\n");
}
void   CyclicReduction2(int n, DistVector__Vector *U, DistVector__Vector *F){

       int t,s,k,nm1;
       pcxx_UserTimerStart(6);
       ResetLocal(U);
       for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
       {
          pcxx_Poll();
          ((*(U))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->ParForwardElim(0,*(F));
        }
       _pcxx_Barrier();
       pcxx_UserTimerStop(6);
       pcxx_UserTimerStart(7);
       for (s = 1 ; (s) < ((n) / (2)) ; s = (s) * (2))
       {
          k = (2) * (s);
          nm1 = (n) -(1);
          ResetLocal(U);
          for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
          {
             pcxx_Poll();
             ((*(U))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->DoSubSetForward(k,nm1,k,s,*(F));
           }
          _pcxx_Barrier();
        }
       pcxx_UserTimerStop(7);
       pcxx_UserTimerStart(8);
       for (s = (n) / (2) ; (s)>=(1) ; s = (s) / (2))
       {
          k = (2) * (s);
          nm1 = (n) -(1);
          ResetLocal(U);
          for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
          {
             pcxx_Poll();
             ((*(U))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->DoSubSetBackward(s,nm1,k,s,*(F));
           }
          _pcxx_Barrier();
        }
       pcxx_UserTimerStop(8);
}
void   sintbody(Vector *f, int m, float **wr, float **wi, int *p, Vector *u){

       int i;
       for (i = 0 ; (i) < (m) ; (i)++)
       {
          f[i].SinTransform(wr,wi,p,&(u[i]));
        }
}
void   poisson_solve(int n, float **wr, float **wi, int *p, DistVector__Vector *U, DistVector__Vector *F){

       int i,j;
       pcxx_UserTimerStart(2);
       ResetLocal(F);
       for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
       {
          pcxx_Poll();
          ((*(F))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->ParSinTransform(wr,wi,p,*(U));
        }
       _pcxx_Barrier();
       pcxx_UserTimerStop(2);
       pcxx_UserTimerStart(3);
       CyclicReduction2(n,U,F);
       pcxx_UserTimerStop(3);
       pcxx_UserTimerStart(4);
       ResetLocal(U);
       for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
       {
          pcxx_Poll();
          ((*(U))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->ParSinTransform(wr,wi,p,*(F));
        }
       _pcxx_Barrier();
       pcxx_UserTimerStop(4);
       pcxx_UserTimerStart(5);
       ResetLocal(U);
       for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
       {
          pcxx_Poll();
          ((*(U))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->ParVector_copy(*(F));
        }
       _pcxx_Barrier();
       pcxx_UserTimerStop(5);
       if ((U)->Is_Local(0)) 
       {
          for (j = 0 ; (j) < (n) ; (j)++)
          {
             ((*(U))(0))->put(0.0,j);
           }
        }
        _pcxx_Barrier();
}
void   Processor_Main(){

       int i,j,n,log2n;
       float s,t;
       double error,temps;
       Vector  *cp,*cp1,*cp2;
       Processors P;
       Distribution Temp(((8) * (64)) + (1),&P,1);
       Align A(((8) * (64)) + (1),0);
       DistVector__Vector F(&Temp,&A,(8) * (64));
       DistVector__Vector U(&Temp,&A,(8) * (64));
       if (ev_class&1) 
       {
          se_event(60122,0);
        }
        pcxx_UserTimerClear(1);
       pcxx_UserTimerClear(2);
       pcxx_UserTimerClear(3);
       pcxx_UserTimerClear(4);
       pcxx_UserTimerClear(5);
       pcxx_UserTimerClear(6);
       pcxx_UserTimerClear(7);
       pcxx_UserTimerClear(8);
       n = (8) * (64);
       log2n = mylog2(n);
       initw((n) / (2),(log2n) -(1),(GlobalVars[pcxx_NodeNumber()].wr),(GlobalVars[pcxx_NodeNumber()].wi),(GlobalVars[pcxx_NodeNumber()].p));
       if ((pcxx_NodeNumber()) == (0)) 
       {
          printf("template set for %d processors\n",64);
        }
        if ((pcxx_NodeNumber()) == (0)) 
       {
          printf("w and p allocated and initialized \n");
        }
        ResetLocal(&(F));
       for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
       {
          pcxx_Poll();
          ((F)((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->resize((n) + (1));
        }
       _pcxx_Barrier();
       ResetLocal(&(U));
       for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
       {
          pcxx_Poll();
          ((U)((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->resize((n) + (1));
        }
       _pcxx_Barrier();
       if ((pcxx_NodeNumber()) == (0)) 
       {
          printf("f and u allocated \n");
        }
        for (i = 0 ; (i)<=(n) ; (i)++)
       {
          for (j = 1 ; (j) < (n) ; (j)++)
          {
             if (F.Is_Local(i)) 
             {
                ((F)(i))->put(((10.0) * (i)) / (j),j);
              }
              if (U.Is_Local(i)) 
             {
                ((U)(i))->put(1.0,j);
              }
            }
        }
       for (i = 0 ; (i)<=(n) ; (i)++)
       {
          if (F.Is_Local(0)) 
          {
             ((F)(0))->put(0.0,i);
           }
           if (F.Is_Local(n)) 
          {
             ((F)(n))->put(0.0,i);
           }
           if (U.Is_Local(0)) 
          {
             ((U)(0))->put(0.0,i);
           }
           if (U.Is_Local(n)) 
          {
             ((U)(n))->put(0.0,i);
           }
           if (F.Is_Local(i)) 
          {
             ((F)(i))->put(0.0,0);
           }
           if (F.Is_Local(i)) 
          {
             ((F)(i))->put(0.0,n);
           }
           if (U.Is_Local(i)) 
          {
             ((U)(i))->put(0.0,0);
           }
           if (U.Is_Local(i)) 
          {
             ((U)(i))->put(0.0,n);
           }
         }
       if ((pcxx_NodeNumber()) == (0)) 
       {
          printf("start solve\n");
        }
        _pcxx_Barrier();
       pcxx_UserTimerStart(1);
       poisson_solve(n,(GlobalVars[pcxx_NodeNumber()].wr),(GlobalVars[pcxx_NodeNumber()].wi),(GlobalVars[pcxx_NodeNumber()].p),&(U),&(F));
       pcxx_UserTimerStop(1);
       if ((pcxx_NodeNumber()) == (0)) 
       {
          printf("end solve \n");
        }
        _pcxx_Barrier();
       temps = pcxx_UserTimerElapsed(1);
       if ((pcxx_NodeNumber()) == (0)) 
       {
          printf("Elapsed time-1 %f\n",temps);
        }
        temps = pcxx_UserTimerElapsed(2);
       if ((pcxx_NodeNumber()) == (0)) 
       {
          printf("Elapsed time-2 %f\n",temps);
        }
        temps = pcxx_UserTimerElapsed(3);
       if ((pcxx_NodeNumber()) == (0)) 
       {
          printf("Elapsed time-3 %f\n",temps);
        }
        temps = pcxx_UserTimerElapsed(4);
       if ((pcxx_NodeNumber()) == (0)) 
       {
          printf("Elapsed time-4 %f\n",temps);
        }
        temps = pcxx_UserTimerElapsed(5);
       if ((pcxx_NodeNumber()) == (0)) 
       {
          printf("Elapsed time-5 %f\n",temps);
        }
        temps = pcxx_UserTimerElapsed(6);
       if ((pcxx_NodeNumber()) == (0)) 
       {
          printf("Elapsed time-6 %f\n",temps);
        }
        temps = pcxx_UserTimerElapsed(7);
       if ((pcxx_NodeNumber()) == (0)) 
       {
          printf("Elapsed time-7 %f\n",temps);
        }
        temps = pcxx_UserTimerElapsed(8);
       if ((pcxx_NodeNumber()) == (0)) 
       {
          printf("Elapsed time-8 %f\n",temps);
        }
        for (i = 1 ; (i) < (n) ; (i)++)
       {
          if (F.Is_Local(i)) 
          {
             cp = (Vector *) U.Get_CopyElem(i);
             cp1 = (Vector *) U.Get_CopyElem((i) -(1));
             cp2 = (Vector *) U.Get_CopyElem((i) + (1));
             for (j = 1 ; (j) < (n) ; (j)++)
             {
                ((F)(i))->put((((((4.0) * ((cp)->get(j))) -((cp1)->get(j))) -((cp2)->get(j))) -((cp)->get((j) -(1)))) -((cp)->get((j) + (1))),j);
              }
             if ( !(U.Is_Local(i))) 
             {
                delete  cp;
              }
              if ( !(U.Is_Local((i) -(1)))) 
             {
                delete  cp1;
              }
              if ( !(U.Is_Local((i) + (1)))) 
             {
                delete  cp2;
              }
            }
         }
       _pcxx_Barrier();
       if ((pcxx_NodeNumber()) == (0)) 
       {
          printf("computing error \n");
          error = 0.0;
          for (i = 1 ; (i) < (n) ; (i)++)
          {
             cp = (Vector *) F.Get_CopyElem(i);
             for (j = 1 ; (j) < (n) ; (j)++)
             {
                error = (error) + ((((cp)->get(j)) -(((10.0) * (i)) / (j))) * (((cp)->get(j)) -(((10.0) * (i)) / (j))));
              }
             if ( !(F.Is_Local(i))) 
             {
                delete  cp;
              }
            }
          printf("Square of L2 error is %e\n",(error) / ((n) * (n)));
          if (((((error) / ((n) * (n))) -(2.207133e-01)) >  (1.e-6)) || ((((error) / ((n) * (n))) -(2.207133e-01)) < ( (-(1.e-6))))) 
          {
             Message("Execution status: Failure.",1);
           }
         }
        _pcxx_Barrier();
}

#include "align_function.h"

void DuplicateGlobalVars(int num_threads)
{
  GlobalVars = (GVars *) malloc ( sizeof(GVars) * num_threads );
}
