/*********************************************************************/
/*                  pC++/Sage++  Copyright (C) 1993                  */
/*  Indiana University  University of Oregon  University of Rennes   */
/*********************************************************************/


//dep2C++ generated
#include "runtime.h"
class  SuperKernel__SparseMatrix ;
class  DistributedArray__SparseMatrix ;
class  DistBlkMatrix__SparseMatrix ;
class  DistBlkVector__Vector ;
class  SuperKernel__Vector ;
class  DistributedArray__Vector ;
class  NewDistArray__Vector ;
class GVars {
public:
int VarpC_9;
int VarpC_8;
int VarpC_7;
int VarpC_6;
int VarpC_5;
int VarpC_4;
int VarpC_3;
int VarpC_2;
int VarpC_1;
int VarpC_0;
double amult;
double tran;
int ks;
double r23;
double r46;
double t23;
double t46;
} *GlobalVars;
extern unsigned long  int ev_class;
extern "C" {
       extern  void  se_init(char *n);
       extern  void  se_event(int e, long int p);
       extern  void  se_long_event(int e, int l, char *p);
       extern  void  se_close();
       extern  void  se_flush();
       extern  void  se_set_and_parse_eventclass(char *p, char *c);
}
int  ComputeMyBlock(int size, int rem, int index){

       int tmp;
       if ( !(rem)) 
       {
          return (index) / (size);
        }
        if ((index) >  ((rem) * ((size) + (1)))) 
       {
          tmp = (index) -((rem) * ((size) + (1)));
          tmp = (tmp) / (size);
          tmp = (tmp) + (rem);
        }
        else{
          tmp = (index) / ((size) + (1));
        }
       return tmp;
}
int  ComputeNbElemBeforeMe(int size, int rem, int index){

       int tmp;
       if ( !(rem)) 
       {
          tmp = (index) / (size);
          return (size) * (tmp);
        }
        if ((index) >  ((rem) * ((size) + (1)))) 
       {
          tmp = (index) -((rem) * ((size) + (1)));
          tmp = (tmp) / (size);
          tmp = ((tmp) * (size)) + ((rem) * ((size) + (1)));
        }
        else{
          tmp = (index) / ((size) + (1));
          tmp = (tmp) * ((size) + (1));
        }
       return tmp;
}
int  ComputeMyIndexInBlock(int size, int rem, int index){

       int tmp;
       return (index) -(ComputeNbElemBeforeMe(size,rem,index));
}
double  Cabs(double x){

       if ((x) >  (0.0)) 
       {
          return x;
        }
        else{
          return  (-(x));
        }
}
class  Vector {
public:
public:
       void  TakeFirstCol(NewDistArray__Vector &array);
public:
       void  CopyElem(DistBlkVector__Vector *v);
public:
       void  asgnm(double s, DistBlkVector__Vector &arg1);
public:
       void  saxpy(double s, DistBlkVector__Vector &arg1, DistBlkVector__Vector &arg2);
public:
       void  masgn(DistBlkVector__Vector &arg1);
public:
       void  pasgn(DistBlkVector__Vector &arg1);
public:
       void  asgn(DistBlkVector__Vector &arg1);
public:
       void  mul(DistBlkVector__Vector &arg1, DistBlkVector__Vector &arg2);
public:
       void  add(DistBlkVector__Vector &arg1, DistBlkVector__Vector &arg2);
public:
       void  sub(DistBlkVector__Vector &arg1, DistBlkVector__Vector &arg2);
public:
       void  LocalBroadcast(DistBlkVector__Vector &array, int step);
public:
       void  gmaxs(double zeta, int step);
public:
       void  gsum(DistBlkVector__Vector &array, int step);
public:
       void  Resetspecialmax(double zeta);
public:
       void  ResetDotProd(DistBlkVector__Vector &arg1);
public:
       double dot_temp;
public:
       Vector  *Self(int i, int j);
public:
       Vector  *Self(int i);
public:
       SuperKernel__Vector  *ThisCollection;
public:
       int index2;
public:
       int index1;
public:
       int Ident;
public:
       void  DeleteTemp();
public:
       void  LocalShiftStep2();
public:
       void  LocalShiftStep1(int dim, int distance);
public:
       void  LocalBroadcastDim2(DistributedArray__Vector *array, int step);
public:
       void  LocalReduceDim2(DistributedArray__Vector *array, int step);
public:
       void  LocalBroadcastDim1(DistributedArray__Vector *array, int step);
public:
       void  LocalBroadcast(DistributedArray__Vector *array, int step);
public:
       void  LocalReduceDim1(DistributedArray__Vector *array, int step);
public:
       void  LocalReduce(DistributedArray__Vector *array, int step);
public:
       void  Set_ThisCollection(DistributedArray__Vector *C);
public:
       void  LocalCopy(DistributedArray__Vector *array);
public:
       void  BroadcastTemp(DistributedArray__Vector &array, int step);
public:
       void  LocalGSum(DistributedArray__Vector &array, int step);
public:
       void  ResetDotProd(DistributedArray__Vector &arg1);
public:
       Vector  *temporaryelement;
public:
       double dotprodtemp;
public:
       void  WhereAmI();
public:
       double data[((1400) / (8)) + (4)];
public:
       int size;
public:
         Vector(){
       
       }
public:
        Vector(int s);
public:
       double  &operator [](int i);
public:
       double  &operator ()(int i);
public:
       Vector operator +(Vector &rhs);
public:
       Vector operator *(Vector &rhs);
public:
       Vector  &operator =(Vector &rhs);
public:
       Vector  &operator +=(Vector &rhs);
public:
       void  allocData(int s, int initval);
public:
       void  allocData(int s);
public:
       void  sub_el(Vector &arg1, Vector &arg2);
public:
       void  add_el(Vector &arg1, Vector &arg2);
public:
       void  mul_el(Vector &arg1, Vector &arg2);
public:
       void  asgn_el(Vector &arg1);
public:
       void  pasgn_el(Vector &arg1);
public:
       void  masgn_el(Vector &arg1);
public:
       int testeq_el(Vector &arg1);
public:
       void  saxpy_el(double s, Vector &arg1, Vector &arg2);
public:
       void  asgnm_el(double s, Vector &arg1);
public:
       double smax(double zeta);
public:
       double norm();
public:
       double Dot(Vector &arg1);
public:
       void  init_elem(int whole_size, int local_size, int addtoelem, int p);
 
};
void  Vector:: init_elem(int whole_size, int local_size, int addtoelem, int p){

       int i;
       if ((index1) < (addtoelem)) 
       {
          size = (local_size) + (1);
        }
        else{
          size = local_size;
        }
}
 Vector:: Vector(int s){

       size = s;
}
void  Vector:: allocData(int s, int initval){

       int i;
       size = s;
       if ((size)>=(((1400) / (8)) + (4))) 
       {
          size = ((1400) / (8)) + (4);
        }
        for (i = 0 ; (i) < (((1400) / (8)) + (4)) ; (i)++)
       {
          data[i] = initval;
        }
       if ((index1) == (0)) 
       {
          data[0] = 0;
        }
 }
void  Vector:: allocData(int s){

       int i;
       size = s;
       if ((size)>=(((1400) / (8)) + (4))) 
       {
          size = ((1400) / (8)) + (4);
        }
        for (i = 0 ; (i) < (((1400) / (8)) + (4)) ; (i)++)
       {
          data[i] = 0;
        }
}
double & Vector:: operator [](int i){

       return data[i];
}
double & Vector:: operator ()(int i){

       return data[i];
}
Vector Vector:: operator +(Vector &rhs){

       Vector T(size);
       int i;
       for (i = 0 ; (i) < (size) ; (i)++)
       {
          T.data[i] = ((this )->data[i]) + (rhs.data[i]);
        }
       return T;
}
Vector Vector:: operator *(Vector &rhs){

       Vector T(size);
       int i;
       for (i = 0 ; (i) < (size) ; (i)++)
       {
          T.data[i] = ((this )->data[i]) * (rhs.data[i]);
        }
       return T;
}
Vector & Vector:: operator =(Vector &rhs){

       int i;
       for (i = 0 ; (i) < (rhs.size) ; (i)++)
       {
          (this )->data[i] = rhs.data[i];
        }
       return *(this );
}
Vector & Vector:: operator +=(Vector &rhs){

       int i;
       for (i = 0 ; (i) < (rhs.size) ; (i)++)
       {
          (this )->data[i] += rhs.data[i];
        }
       return *(this );
}
double Vector:: norm(){

       int i;
       double x;
       x = 0.0;
       for (i = 0 ; (i) < (size) ; (i)++)
       {
          x += (data[i]) * (data[i]);
        }
       return x;
}
double Vector:: Dot(Vector &arg1){

       int i;
       double x;
       double  *p1,*p2;
       x = 0.0;
       p1 = &((this )->data[0]);
       p2 = &(arg1.data[0]);
       for (i = 0 ; (i) < (size) ; (i)++)
       {
          x += (*((p1)++)) * (*((p2)++));
        }
       return x;
}
double Vector:: smax(double zeta){

       int i;
       double x;
       double  *p1,*p2;
       x = zeta;
       for (i = 1 ; (i) < (size) ; (i)++)
       {
          if ((Cabs((this )->data[i])) >  (x)) 
          {
             x = Cabs((this )->data[i]);
           }
         }
       return x;
}
void  Vector:: sub_el(Vector &arg1, Vector &arg2){

       int i;
       for (i = 0 ; (i) < (size) ; (i)++)
       {
          (this )->data[i] = (arg1.data[i]) -(arg2.data[i]);
        }
}
void  Vector:: add_el(Vector &arg1, Vector &arg2){

       int i;
       for (i = 0 ; (i) < (size) ; (i)++)
       {
          (this )->data[i] = (arg1.data[i]) + (arg2.data[i]);
        }
}
void  Vector:: mul_el(Vector &arg1, Vector &arg2){

       int i;
       for (i = 0 ; (i) < (size) ; (i)++)
       {
          (this )->data[i] = (arg1.data[i]) * (arg2.data[i]);
        }
}
void  Vector:: asgn_el(Vector &arg1){

       int i;
       for (i = 0 ; (i) < (size) ; (i)++)
       {
          (this )->data[i] = arg1.data[i];
        }
}
void  Vector:: pasgn_el(Vector &arg1){

       int i;
       for (i = 0 ; (i) < (size) ; (i)++)
       {
          (this )->data[i] += arg1.data[i];
        }
}
void  Vector:: masgn_el(Vector &arg1){

       int i;
       for (i = 0 ; (i) < (size) ; (i)++)
       {
          (this )->data[i] = ((this )->data[i]) * (arg1.data[i]);
        }
}
int Vector:: testeq_el(Vector &arg1){

       int i,j;
       j = 1;
       for (i = 0 ; (i) < (size) ; (i)++)
       {
          j = (j) && (((this )->data[i]) == (arg1.data[i]));
        }
       return j;
}
void  Vector:: saxpy_el(double s, Vector &arg1, Vector &arg2){

       int i;
       double  *p1,*p2,*p3;
       p1 = &((this )->data[0]);
       p2 = &(arg1.data[0]);
       p3 = &(arg2.data[0]);
       for (i = 0 ; (i) < (size) ; (i)++)
       {
          *((p1)++) = ((s) * (*((p2)++))) + (*((p3)++));
        }
}
void  Vector:: asgnm_el(double s, Vector &arg1){

       int i;
       for (i = 0 ; (i) < (size) ; (i)++)
       {
          (this )->data[i] = (s) * (arg1.data[i]);
        }
}
class  data_item {
public:
private:
       double val;
private:
       int row,col;
private:
       data_item  *NextInRow;
private:
       data_item  *NextInCol;
public:
         data_item(double x, int r, int c, data_item *NextRow, data_item *NextCol){
       
          val = x;
          row = r;
          col = c;
          NextInRow = NextRow;
          NextInCol = NextCol;
       }
public:
       void   init(double x, int r, int c, data_item *NextRow, data_item *NextCol){
       
          val = x;
          row = r;
          col = c;
          NextInRow = NextRow;
          NextInCol = NextCol;
       }
public:
       double  value(){
       
          return val;
       }
public:
       void   set_value(double v){
       
          val = v;
       }
public:
       int  current_row(){
       
          return row;
       }
public:
       int  current_column(){
       
          return col;
       }
public:
       data_item *  next_in_row(){
       
          return NextInRow;
       }
public:
       void   set_next_in_row(data_item *n){
       
          NextInRow = n;
       }
public:
       data_item *  next_in_column(){
       
          return NextInCol;
       }
public:
       void   set_next_in_column(data_item *n){
       
          NextInCol = n;
       }
 
};
typedef  data_item  *data_ptr;
class  SparseMatrix {
public:
public:
       SparseMatrix  *Self(int i, int j);
public:
       SparseMatrix  *Self(int i);
public:
       SuperKernel__SparseMatrix  *ThisCollection;
public:
       int index2;
public:
       int index1;
public:
       int Ident;
public:
       void  DeleteTemp();
public:
       void  LocalShiftStep2();
public:
       void  LocalShiftStep1(int dim, int distance);
public:
       void  LocalBroadcastDim2(DistributedArray__SparseMatrix *array, int step);
public:
       void  LocalReduceDim2(DistributedArray__SparseMatrix *array, int step);
public:
       void  LocalBroadcastDim1(DistributedArray__SparseMatrix *array, int step);
public:
       void  LocalBroadcast(DistributedArray__SparseMatrix *array, int step);
public:
       void  LocalReduceDim1(DistributedArray__SparseMatrix *array, int step);
public:
       void  LocalReduce(DistributedArray__SparseMatrix *array, int step);
public:
       void  Set_ThisCollection(DistributedArray__SparseMatrix *C);
public:
       void  LocalCopy(DistributedArray__SparseMatrix *array);
public:
       void  BroadcastTemp(DistributedArray__SparseMatrix &array, int step);
public:
       void  LocalGSum(DistributedArray__SparseMatrix &array, int step);
public:
       void  ResetDotProd(DistributedArray__SparseMatrix &arg1);
public:
       SparseMatrix  *temporaryelement;
public:
       double dotprodtemp;
public:
       void  WhereAmI();
public:
       void  LocalMatVect(NewDistArray__Vector &tmp);
public:
       void  LocalBroadcast(int step);
public:
       double tempforgetvalue;
private:
       int rows,columns;
private:
       int p;
private:
       data_ptr  *r;
private:
       data_ptr  *c;
private:
       double  *T;
private:
       double  *T2;
public:
       data_ptr  rowp(int i){
       
          return r[i];
       }
public:
       data_ptr  colp(int i){
       
          return c[i];
       }
public:
       void  initialize(int rs, int cs, int pes);
public:
       void  insert_element(double val, int row, int col);
public:
       double value(int row, int col);
public:
       void  amux(Vector &Vout, Vector &Vin);
public:
       SparseMatrix &  operator =(SparseMatrix &rhs){
       
          return rhs;
       }
public:
       SparseMatrix &  operator +=(SparseMatrix &rhs){
       
          return rhs;
       }
public:
       void   allocData(int s, int initval){
       
       }
public:
       void   allocData(int s){
       
       }
public:
       double  Dot(SparseMatrix &arg1){
       
          return 0;
       }
 
};
void  SparseMatrix:: initialize(int rs, int cs, int pes){

       int i,thisp;
       thisp = index1;
       rows = rs;
       columns = cs;
       p = pes;
       r = (data_ptr *) new data_ptr [rs] ;
       c = (data_ptr *) new data_ptr [columns] ;
       for (i = 0 ; (i) < (rs) ; (i)++)
       {
          r[i] = 0;
        }
       for (i = 0 ; (i) < (cs) ; (i)++)
       {
          c[i] = 0;
        }
}
void  SparseMatrix:: insert_element(double val, int row, int col){

       data_ptr p;
       data_ptr q,s;
       p = new data_item (val,row,col,0,0);
       if ((p) == (0)) 
       {
          printf("out of space for new inserts!\n");
          return ;
        }
        if (((row) >  (rows)) || ((row) < (0))) 
       {
          printf("(%d,%d) out of range max rows = %d\n",row,col,rows);
          return ;
        }
        if (((col) >  (columns)) || ((col) < (0))) 
       {
          printf("(%d %d) out of range max cols = %d\n",row,col,columns);
          return ;
        }
        (p)->init(val,row,col,0,0);
       if ((r[row]) == (0)) 
       {
          r[row] = p;
        }
        else{
          q = r[row];
          s = 0;
          while (((q)!=(0)) && (((q)->current_column()) < (col)))
          {
             s = q;
             q = (q)->next_in_row();
           }
          if (((q)!=(0)) && (((q)->current_column()) == (col))) 
          {
             (q)->set_value(val);
             return ;
           }
           if ((s) == (0)) 
          {
             q = r[row];
             r[row] = p;
           }
           else{
             (s)->set_next_in_row(p);
           }
          (p)->set_next_in_row(q);
        }
       if ((c[col]) == (0)) 
       {
          c[col] = p;
        }
        else{
          q = c[col];
          s = 0;
          while (((q)!=(0)) && (((q)->current_row()) < (row)))
          {
             s = q;
             q = (q)->next_in_column();
           }
          if ((s) == (0)) 
          {
             q = c[col];
             c[col] = p;
           }
           else{
             (s)->set_next_in_column(p);
           }
          (p)->set_next_in_column(q);
        }
}
double SparseMatrix:: value(int row, int col){

       data_ptr p;
       if (((row) >  (rows)) || ((row) < (0))) 
       {
          printf("(%d,%d) out of range max rows = %d\n",row,col,rows);
          return 0.0;
        }
        if (((col) >  (columns)) || ((col) < (0))) 
       {
          printf("(%d %d) out of range max cols = %d\n",row,col,columns);
          return 0.0;
        }
        p = rowp(row);
       while (((p)!=(0)) && (((p)->current_column()) < (col)))
       {
          p = (p)->next_in_row();
        }
       if ((p) == (0)) 
       {
          return 0.0;
        }
        else{
          if (((p)->current_column()) == (col)) 
          {
             return (p)->value();
           }
         }
       return 0.0;
}
void  SparseMatrix:: amux(Vector &Vout, Vector &V){

       int i,r,l;
       data_ptr m;
       double v;
       Vector TV(Vout.size);
       for (i = 0 ; (i) < (((1400) / (8)) + (4)) ; (i)++)
       {
          TV.data[i] = 0.0;
        }
       for (i = 0 ; (i) < (columns) ; (i)++)
       {
          m = colp(i);
          v = (V)(i);
          while ((m)!=(0))
          {
             r = (m)->current_row();
             TV.data[r] += ((m)->value()) * (v);
             m = (m)->next_in_column();
           }
        }
       for (i = 0 ; (i) < (((1400) / (8)) + (4)) ; (i)++)
       {
          Vout.data[i] = TV.data[i];
        }
}
struct INFO_HEAD {
       int LocalTraversalCount;
       char  *CurrentCollectionTraversal;
       int type;
       int number_dimension;
       int element_size;
       int nb_element;
       int dim1size,dim2size,dim3size;
       int  **Table;
       int  **Where;
} ;
typedef  struct INFO_HEAD *PTR_INFO;
typedef  struct  {
       int numproc;
       int eventclass;
       char  *tracefile;
       int numthread;
       int shmemsize;
       int stacksize;
} pCC_PARAM_t;
class  Processors {
public:
public:
       int dimension;
 
};
class  Distribution {
public:
public:
       int nbdim;
public:
       int nbelement;
public:
       int dim1size,dim2size,dim3size;
public:
       int dist1,dist2,dist3;
public:
       Processors P;
public:
        Distribution();
public:
        Distribution(int d1size, Processors *P, int dt1);
public:
        Distribution(int d1size, int d2size, Processors *P, int dt1, int dt2);
public:
        Distribution(int d1size, int d2size, int d3size, Processors *P, int dt1, int dt2, int dt3);
public:
       int GiveElementProc(int i);
public:
       int GiveElementProc(int i, int j);
public:
       int GiveElementProc(int i, int j, int k);
 
};
 Distribution:: Distribution(){

       nbdim = 1;
       nbelement = pcxx_TotalNodes();
       dim1size = pcxx_TotalNodes();
       dist1 = 2;
}
 Distribution:: Distribution(int d1size, Processors *P, int dt1){

       nbdim = 1;
       nbelement = d1size;
       dim1size = d1size;
       dist1 = dt1;
}
 Distribution:: Distribution(int d1size, int d2size, Processors *P, int dt1, int dt2){

       nbdim = 2;
       nbelement = (d1size) * (d2size);
       dim1size = d1size;
       dim2size = d2size;
       dist1 = dt1;
       dist2 = dt2;
}
 Distribution:: Distribution(int d1size, int d2size, int d3size, Processors *P, int dt1, int dt2, int dt3){

       nbdim = 2;
       nbelement = ((d1size) * (d2size)) * (d3size);
       dim1size = d1size;
       dim2size = d2size;
       dim3size = d3size;
       dist1 = dt1;
       dist2 = dt2;
       dist3 = dt3;
       Message("Distribution(): Sorry, 3D template not implemented.",1);
}
int Distribution:: GiveElementProc(int i){

       int proc = 0;
       int x,p,rem,q;
       switch (dist1)
       {
          case 1:
          p = (dim1size) / (pcxx_TotalNodes());
          rem = (dim1size) -((pcxx_TotalNodes()) * (p));
          q = ((p)<=(rem))?(p) + (1):p;
          proc = (i) / (q);
          if ((proc)>=(pcxx_TotalNodes())) 
          {
             proc = ((pcxx_TotalNodes()) -(1)) -((proc)% (pcxx_TotalNodes()));
           }
           break;
          case 2:
          proc = (i)% (pcxx_TotalNodes());
          break;
          case 3:
          Message("GiveElementProc()_1D: WHOLE has no meaning in 1D Distribution,",0);
          Message("GiveElementProc()_1D: use BLOCK distribution instead.",0);
          p = (dim1size) / (pcxx_TotalNodes());
          rem = (dim1size) -((pcxx_TotalNodes()) * (p));
          q = ((p)<=(rem))?(p) + (1):p;
          proc = (i) / (q);
          if ((proc)>=(pcxx_TotalNodes())) 
          {
             proc = ((pcxx_TotalNodes()) -(1)) -((proc)% (pcxx_TotalNodes()));
           }
           break;
          default:
          Message("GiveElementProc()_1D: Unknow distribution for 1D Distribution.",1);
        }
       if ((proc)>=(pcxx_TotalNodes())) 
       {
          Message("GiveElementProc()_1D: Error in 1D Distribution object.",0);
          proc = (proc)% (pcxx_TotalNodes());
        }
        return proc;
}
int Distribution:: GiveElementProc(int i, int j){

       int proc = 0;
       int index1,index2,sq,p,rem,q;
       float x,y;
       if (((dist1) == (4)) && ((dist2) == (4))) 
       {
          q = (int) QGridToProc(i,j,dim1size);
          x = ((dim1size) * (dim2size)) / ((float) pcxx_TotalNodes());
          y = (q) / (x);
          proc = (int) y;
          if ((proc)>=(pcxx_TotalNodes())) 
          {
             Message("GiveElementProc()_2D: Processor # Out of Bounds)",0);
             proc = (proc)% (pcxx_TotalNodes());
           }
           return proc;
        }
        sq = (int) sqrt((double) pcxx_TotalNodes());
       switch (dist1)
       {
          case 1:
          p = (dim1size) / (sq);
          rem = (dim1size) -((sq) * (p));
          q = ((p)<=(rem))?(p) + (1):p;
          index1 = (i) / (q);
          if ((index1)>=(sq)) 
          {
             index1 = ((sq) -(1)) -((index1)% (sq));
           }
           break;
          case 2:
          index1 = (i)% (sq);
          break;
          case 3:
          index1 = 0;
          break;
          default:
          Message("GiveElementProc()_2D: Unknow distribution for 2D Distribution.",1);
        }
       switch (dist2)
       {
          case 1:
          p = (dim2size) / (sq);
          rem = (dim2size) -((sq) * (p));
          q = ((p)<=(rem))?(p) + (1):p;
          index2 = (j) / (q);
          if ((index2)>=(sq)) 
          {
             index2 = ((sq) -(1)) -((index2)% (sq));
           }
           break;
          case 2:
          index2 = (j)% (sq);
          break;
          case 3:
          index2 = 0;
          break;
          default:
          Message("GiveElementProc()_2D: Unknow distribution for 2D Distribution.",1);
        }
       proc = (index1) + ((index2) * (sq));
       if ((proc)>=(pcxx_TotalNodes())) 
       {
          Message("GiveElementProc()_2D: Error in 2D Distribution object.",0);
          proc = (proc)% (pcxx_TotalNodes());
        }
        return proc;
}
int Distribution:: GiveElementProc(int i, int j, int k){

       Message("GiveElementProc()_3D: Sorry, 3D template not implemented.",1);
       return 0;
}
class  Align {
public:
public:
       int nbelement;
public:
       int nbdim;
public:
       int dim1size,dim2size,dim3size;
public:
       int ret_index1;
public:
       int ret_index2;
public:
       int ret_index3;
public:
       int chosen;
public:
         Align(int i, int j, char *str){
       
       }
public:
         Align(int n1, int n2, int choix){
       
          nbdim = 2;
          dim1size = n1;
          dim2size = n2;
          nbelement = (n1) * (n2);
          chosen = choix;
       }
public:
         Align(int n1, int choix){
       
          nbdim = 1;
          dim1size = n1;
          dim2size = 0;
          nbelement = n1;
          chosen = choix;
       }
public:
       void  align_func(int var_i, int var_j);
 
};
class  Kernel {
public:
public:
       Distribution  *Tmp;
public:
       Align  *align;
       struct INFO_HEAD GlobalInfo;
public:
       int CollectionNumber;
public:
       int CollectionNumber_Type;
public:
       int  *buffer;
public:
        Kernel(Distribution *T, Align *A, int sizelem);
public:
        Kernel(Kernel *col);
public:
        ~Kernel();
public:
       int Is_Local(int index);
public:
       int Is_Local(int index1, int index2);
public:
       int GlobalIndex(int i);
public:
       int GlobalIndex(int i, int j);
public:
       int Get_2DHighIndex(int index);
public:
       int Get_2DLowIndex(int index);
public:
       int AllocatedProc(int index);
public:
       int AllocatedProc(int index1, int index2);
public:
       int Install_Collection(Distribution *T, Align *A, int sizeelem);
public:
       int  *Get_Element(int index);
public:
       int  *Get_Element(int index1, int index2);
public:
       int  *Get_ElementPart(int index, int startof, int size);
public:
       int  *Get_ElementPart(int index1, int index2, int startof, int size);
public:
       int Get_ElementPart_Int(int index1, int startof);
public:
       float Get_ElementPart_Float(int index1, int startof);
public:
       double Get_ElementPart_Double(int index1, int startof);
public:
       int Get_ElementPart_Int(int index1, int index2, int startof);
public:
       float Get_ElementPart_Float(int index1, int index2, int startof);
public:
       double Get_ElementPart_Double(int index1, int index2, int startof);
public:
       int  *Get_CopyElem(int index);
public:
       int  *Get_CopyElem(int index1, int index2);
public:
       void  Fetch_Element(int index, int *buf, int startof, int size);
 
};
int Kernel:: AllocatedProc(int index){

       int proc = 0;
       (align)->align_func(index,0);
       if (((Tmp)->nbdim) == (1)) 
       {
          proc = (Tmp)->GiveElementProc((align)->ret_index1);
        }
        else{
          proc = (Tmp)->GiveElementProc((align)->ret_index1,(align)->ret_index2);
        }
       return proc;
}
int Kernel:: AllocatedProc(int index1, int index2){

       int proc = 0;
       (align)->align_func(index1,index2);
       proc = (Tmp)->GiveElementProc((align)->ret_index1,(align)->ret_index2);
       return proc;
}
int Kernel:: GlobalIndex(int index){

       return index;
}
int Kernel:: GlobalIndex(int index1, int index2){

       return (index1) + ((index2) * (GlobalInfo.dim1size));
}
int Kernel:: Get_2DHighIndex(int index){

       return (index) / (GlobalInfo.dim1size);
}
int Kernel:: Get_2DLowIndex(int index){

       return (index)% (GlobalInfo.dim1size);
}
int Kernel:: Is_Local(int index){

       if ((GlobalInfo.Table[GlobalIndex(index)]) == ((int *) 0)) 
       {
          return 0;
        }
        else{
          return 1;
        }
}
int Kernel:: Is_Local(int index1, int index2){

       if ((GlobalInfo.Table[GlobalIndex(index1,index2)]) == ((int *) 0)) 
       {
          return 0;
        }
        else{
          return 1;
        }
}
 Kernel:: Kernel(Distribution *T, Align *A, int sizelem){

       if (( !(T)) || ( !(A))) 
       {
          Message("Kernel(): No alignement or template provided.",1);
        }
        Tmp = T;
       align = A;
       if (((A)->nbelement) >  ((T)->nbelement)) 
       {
          Message("Kernel(): Elements in Align are more than elements in Distribution.",0);
        }
        GlobalInfo.type =  (-(1));
       GlobalInfo.number_dimension = (A)->nbdim;
       GlobalInfo.element_size = sizelem;
       GlobalInfo.nb_element = (A)->nbelement;
       GlobalInfo.dim1size = (A)->dim1size;
       GlobalInfo.dim2size = (A)->dim2size;
       GlobalInfo.dim3size = (A)->dim3size;
       if ( !(Install_Collection(T,A,sizelem))) 
       {
          Message("Kernel(): Error in creating collection.",1);
        }
        _pcxx_Barrier();
}
 Kernel:: Kernel(Kernel *col){

       Distribution  *T;
       Align  *A;
       int sizelem;
       int i;
       if ( !(col)) 
       {
          Message("Kernel(): Collection not provided.",1);
        }
        T = (col)->Tmp;
       A = (col)->align;
       sizelem = (col)->GlobalInfo.element_size;
       if (( !(T)) || ( !(A))) 
       {
          Message("Kernel(): No alignement or template provided.",1);
        }
        Tmp = T;
       align = A;
       GlobalInfo.type =  (-(1));
       GlobalInfo.number_dimension = (A)->nbdim;
       GlobalInfo.element_size = sizelem;
       GlobalInfo.nb_element = (A)->nbelement;
       GlobalInfo.dim1size = (A)->dim1size;
       GlobalInfo.dim2size = (A)->dim2size;
       GlobalInfo.dim3size = (A)->dim3size;
       if ( !(Install_Collection(T,A,sizelem))) 
       {
          Message("Kernel(): Error in creating collection.",1);
        }
        for (i = 0 ; (i) < (GlobalInfo.nb_element) ; (i)++)
       {
          if ((GlobalInfo.Table[i]) && ((col)->GlobalInfo.Table[i])) 
          {
             bcopy((char *) (col)->GlobalInfo.Table[i],(char *) GlobalInfo.Table[i],sizelem);
           }
         }
       _pcxx_Barrier();
}
void  Kernel:: Fetch_Element(int index, int *buf, int startof, int size){

       int wh,offset;
       int data1,data2,data3,data4;
       int cs;
       int  *pt;
       if ((GlobalInfo.Table[index])!=(0)) 
       {
          pt = GlobalInfo.Table[index];
        }
        else{
          pt = (int *) GlobalInfo.Where[index];
        }
       if ( !(pt)) 
       {
          Message("Element not found",0);
        }
        if (((size)!=( (-(1)))) || ((GlobalInfo.element_size)<=(16))) 
       {
          cs = size;
        }
        if ((size) == ( (-(1)))) 
       {
          cs = (GlobalInfo.element_size) / (sizeof (int) );
        }
        else{
          cs = size;
        }
       for (offset = startof ; (offset) < ((cs) + (startof)) ; offset = (offset) + (4))
       {
          buf[(offset) -(startof)] = pt[offset];
          buf[((offset) -(startof)) + (1)] = pt[(offset) + (1)];
          buf[((offset) -(startof)) + (2)] = pt[(offset) + (2)];
          buf[((offset) -(startof)) + (3)] = pt[(offset) + (3)];
        }
}
int * Kernel:: Get_Element(int index){

       int wh,offset;
       if ((GlobalInfo.number_dimension) == (2)) 
       {
          return Get_Element(Get_2DLowIndex(index),Get_2DHighIndex(index));
        }
        if (ev_class&8) 
       {
          se_event(60165,CollectionNumber);
        }
        if (ev_class&8) 
       {
          se_event(60166,GlobalIndex(index));
        }
        if (Is_Local(index)) 
       {
          if ( !(GlobalInfo.Table[GlobalIndex(index)])) 
          {
             Message("Get_Element_1D: Error in loading local element.",1);
           }
           return GlobalInfo.Table[GlobalIndex(index)];
        }
        else{
          return (int *) GlobalInfo.Where[GlobalIndex(index)];
        }
}
int * Kernel:: Get_Element(int index1, int index2){

       int wh,offset;
       if (ev_class&8) 
       {
          se_event(60165,CollectionNumber);
        }
        if (ev_class&8) 
       {
          se_event(60166,GlobalIndex(index1,index2));
        }
        if (Is_Local(index1,index2)) 
       {
          if ( !(GlobalInfo.Table[GlobalIndex(index1,index2)])) 
          {
             Message("Get_Element_2D: Error in loading local element.",1);
           }
           return GlobalInfo.Table[GlobalIndex(index1,index2)];
        }
        else{
          return (int *) GlobalInfo.Where[GlobalIndex(index1,index2)];
        }
}
int * Kernel:: Get_ElementPart(int index, int startof, int size){

       int wh,offset;
       if ((GlobalInfo.number_dimension) == (2)) 
       {
          return Get_ElementPart(Get_2DLowIndex(index),Get_2DHighIndex(index),startof,size);
        }
        if (ev_class&8) 
       {
          se_event(60165,CollectionNumber);
        }
        if (ev_class&8) 
       {
          se_event(60166,GlobalIndex(index));
        }
        if (Is_Local(index)) 
       {
          if ( !(GlobalInfo.Table[GlobalIndex(index)])) 
          {
             Message("Get_ElementPart_1D: Error in loading local element.",1);
           }
           return (GlobalInfo.Table[GlobalIndex(index)]) + (startof);
        }
        else{
          return ((int *) GlobalInfo.Where[GlobalIndex(index)]) + (startof);
        }
}
int * Kernel:: Get_ElementPart(int index1, int index2, int startof, int size){

       int wh,offset;
       if (ev_class&8) 
       {
          se_event(60165,CollectionNumber);
        }
        if (ev_class&8) 
       {
          se_event(60166,GlobalIndex(index1,index2));
        }
        if (Is_Local(index1,index2)) 
       {
          if ( !(GlobalInfo.Table[GlobalIndex(index1,index2)])) 
          {
             Message("Get_ElementPart_2D: Error in loading local element.",1);
           }
           return (GlobalInfo.Table[GlobalIndex(index1,index2)]) + (startof);
        }
        else{
          return ((int *) GlobalInfo.Where[GlobalIndex(index1,index2)]) + (startof);
        }
}
int Kernel:: Get_ElementPart_Int(int index, int startof){

       int wh,offset;
       if (ev_class&8) 
       {
          se_event(60165,CollectionNumber);
        }
        if (ev_class&8) 
       {
          se_event(60166,GlobalIndex(index));
        }
        if (Is_Local(index)) 
       {
          if ( !(GlobalInfo.Table[GlobalIndex(index)])) 
          {
             Message("Get_ElementPart_Int_1D: Error in loading local element.",1);
           }
           return (int) *((int *) (GlobalInfo.Table[GlobalIndex(index)]) + (startof));
        }
        else{
          return (int) *((int *) (GlobalInfo.Where[GlobalIndex(index)]) + (startof));
        }
}
float Kernel:: Get_ElementPart_Float(int index, int startof){

       int wh,offset;
       if (ev_class&8) 
       {
          se_event(60165,CollectionNumber);
        }
        if (ev_class&8) 
       {
          se_event(60166,GlobalIndex(index));
        }
        if (Is_Local(index)) 
       {
          if ( !(GlobalInfo.Table[GlobalIndex(index)])) 
          {
             Message("Get_ElementPart_Float_1D: Error in loading local element.",1);
           }
           return (float) *((float *) (GlobalInfo.Table[GlobalIndex(index)]) + (startof));
        }
        else{
          return (float) *((float *) (GlobalInfo.Where[GlobalIndex(index)]) + (startof));
        }
}
double Kernel:: Get_ElementPart_Double(int index, int startof){

       int wh,offset;
       if (ev_class&8) 
       {
          se_event(60165,CollectionNumber);
        }
        if (ev_class&8) 
       {
          se_event(60166,GlobalIndex(index));
        }
        if (Is_Local(index)) 
       {
          if ( !(GlobalInfo.Table[GlobalIndex(index)])) 
          {
             Message("Get_ElementPart_Double_1D: Error in loading local element.",1);
           }
           return (double) *((double *) (GlobalInfo.Table[GlobalIndex(index)]) + (startof));
        }
        else{
          return (double) *((double *) (GlobalInfo.Where[GlobalIndex(index)]) + (startof));
        }
}
int Kernel:: Get_ElementPart_Int(int index1, int index2, int startof){

       int wh,offset;
       if (ev_class&8) 
       {
          se_event(60165,CollectionNumber);
        }
        if (ev_class&8) 
       {
          se_event(60166,GlobalIndex(index1,index2));
        }
        if (Is_Local(index1,index2)) 
       {
          if ( !(GlobalInfo.Table[GlobalIndex(index1,index2)])) 
          {
             Message("Get_ElementPart_Int_2D: Error in loading local element.",1);
           }
           return (int) *((int *) (GlobalInfo.Table[GlobalIndex(index1,index2)]) + (startof));
        }
        else{
          return (int) *((int *) (GlobalInfo.Where[GlobalIndex(index1,index2)]) + (startof));
        }
}
float Kernel:: Get_ElementPart_Float(int index1, int index2, int startof){

       int wh,offset;
       if (ev_class&8) 
       {
          se_event(60165,CollectionNumber);
        }
        if (ev_class&8) 
       {
          se_event(60166,GlobalIndex(index1,index2));
        }
        if (Is_Local(index1,index2)) 
       {
          if ( !(GlobalInfo.Table[GlobalIndex(index1,index2)])) 
          {
             Message("Get_ElementPart_Float_2D: Error in loading local element.",1);
           }
           return (float) *((float *) (GlobalInfo.Table[GlobalIndex(index1,index2)]) + (startof));
        }
        else{
          return (float) *((float *) (GlobalInfo.Where[GlobalIndex(index1,index2)]) + (startof));
        }
}
double Kernel:: Get_ElementPart_Double(int index1, int index2, int startof){

       int wh,offset;
       if (ev_class&8) 
       {
          se_event(60165,CollectionNumber);
        }
        if (ev_class&8) 
       {
          se_event(60166,GlobalIndex(index1,index2));
        }
        if (Is_Local(index1,index2)) 
       {
          if ( !(GlobalInfo.Table[GlobalIndex(index1,index2)])) 
          {
             Message("Get_ElementPart_Double_2D: Error in loading local element.",1);
           }
           return (double) *((double *) (GlobalInfo.Table[GlobalIndex(index1,index2)]) + (startof));
        }
        else{
          return (double) *((double *) (GlobalInfo.Where[GlobalIndex(index1,index2)]) + (startof));
        }
}
int * Kernel:: Get_CopyElem(int index){

       int wh,offset;
       int  *NBuf;
       if ((GlobalInfo.number_dimension) == (2)) 
       {
          return Get_CopyElem(Get_2DLowIndex(index),Get_2DHighIndex(index));
        }
        if (ev_class&8) 
       {
          se_event(60165,CollectionNumber);
        }
        if (ev_class&8) 
       {
          se_event(60166,GlobalIndex(index));
        }
        if (Is_Local(index)) 
       {
          if ( !(GlobalInfo.Table[GlobalIndex(index)])) 
          {
             Message("Get_CopyElem_1D: Error in loading local element.",1);
           }
           return GlobalInfo.Table[GlobalIndex(index)];
        }
        NBuf = new int [((GlobalInfo.element_size) / (sizeof(int ))) + (4)] ;
       Fetch_Element(GlobalIndex(index),NBuf,0, (-(1)));
       return NBuf;
}
int * Kernel:: Get_CopyElem(int index1, int index2){

       int wh,offset;
       int  *NBuf;
       if (ev_class&8) 
       {
          se_event(60165,CollectionNumber);
        }
        if (ev_class&8) 
       {
          se_event(60166,GlobalIndex(index1,index2));
        }
        if (Is_Local(index1,index2)) 
       {
          if ( !(GlobalInfo.Table[GlobalIndex(index1,index2)])) 
          {
             Message("Get_CopyElem_2D: Error in loading local element",1);
           }
           return GlobalInfo.Table[GlobalIndex(index1,index2)];
        }
        NBuf = new int [((GlobalInfo.element_size) / (sizeof(int ))) + (4)] ;
       Fetch_Element(GlobalIndex(index1,index2),NBuf,0, (-(1)));
       return NBuf;
}
int Kernel:: Install_Collection(Distribution *T, Align *A, int sizeelem){

       int i,j;
       int proc;
       int count;
       int  *allocated;
       int  **ElemAllocVector;
       CollectionNumber = GetNumberOfCollection();
       IncNumberOfCollection();
       if (ev_class&8) 
       {
          se_event(60150,CollectionNumber);
        }
        if (ev_class&8) 
       {
          se_event(60151,GlobalInfo.number_dimension);
        }
        if (ev_class&8) 
       {
          se_event(60152,GlobalInfo.element_size);
        }
        if (ev_class&8) 
       {
          se_event(60153,GlobalInfo.nb_element);
        }
        if (ev_class&8) 
       {
          se_event(60154,GlobalInfo.dim1size);
        }
        if (ev_class&8) 
       {
          se_event(60155,GlobalInfo.dim2size);
        }
        GlobalInfo.Table = (int **) malloc(((A)->nbelement) * (sizeof (int *) ));
       if ((GlobalInfo.Table) == (0)) 
       {
          Message("Install_Collection: unable to allocate space.",1);
        }
        GlobalInfo.Where = (int **) malloc(((A)->nbelement) * (sizeof (int *) ));
       if ((GlobalInfo.Where) == (0)) 
       {
          Message("Install_Collection : unable to allocate space",1);
        }
        SetTableOfCollection(CollectionNumber,(char *) &(GlobalInfo));
       buffer = new int [((sizeelem) / (sizeof(int ))) + (4)] ;
       if (((A)->nbelement) == (0)) 
       {
          Message("No Element in the collection",1);
        }
        count = 0;
       if ((GlobalInfo.number_dimension) == (1)) 
       {
          for (i = 0 ; (i) < (GlobalInfo.dim1size) ; (i)++)
          {
             if ((AllocatedProc(i)) == (pcxx_NodeNumber())) 
             {
                (count)++;
              }
            }
        }
        else{
          if ((GlobalInfo.number_dimension) == (2)) 
          {
             for (i = 0 ; (i) < (GlobalInfo.dim1size) ; (i)++)
             {
                for (j = 0 ; (j) < (GlobalInfo.dim2size) ; (j)++)
                {
                   if ((AllocatedProc(i,j)) == (pcxx_NodeNumber())) 
                   {
                      (count)++;
                    }
                  }
              }
           }
           else{
             if ((GlobalInfo.number_dimension) >  (2)) 
             {
                Message("Install_Collection(): 3D implementation not available.",1);
              }
            }
        }
       AweAllocElemSpace(pcxx_NodeNumber(),(count) * ((sizeelem) + ((4) * (sizeof (int) ))));
       _pcxx_Barrier();
       ElemAllocVector = (int **) malloc((pcxx_TotalNodes()) * (sizeof (int *) ));
       for (i = 0 ; (i) < (pcxx_TotalNodes()) ; (i)++)
       {
          ElemAllocVector[i] = (int *) AweGetElemSpacePtr(i);
        }
       if ((GlobalInfo.number_dimension) == (1)) 
       {
          for (i = 0 ; (i) < (GlobalInfo.dim1size) ; (i)++)
          {
             proc = AllocatedProc(i);
             allocated = ElemAllocVector[proc];
             ElemAllocVector[proc] += ((sizeelem) / (sizeof (int) )) + (4);
             if ((proc) == (pcxx_NodeNumber())) 
             {
                GlobalInfo.Table[GlobalIndex(i)] = allocated;
                GlobalInfo.Where[GlobalIndex(i)] = (int *) 0;
                if (ev_class&8) 
                {
                   se_event(60160,GlobalIndex(i));
                 }
               }
              else{
                GlobalInfo.Table[GlobalIndex(i)] = (int *) 0;
                GlobalInfo.Where[GlobalIndex(i)] = allocated;
              }
           }
        }
        else{
          if ((GlobalInfo.number_dimension) == (2)) 
          {
             for (i = 0 ; (i) < (GlobalInfo.dim1size) ; (i)++)
             {
                for (j = 0 ; (j) < (GlobalInfo.dim2size) ; (j)++)
                {
                   proc = AllocatedProc(i,j);
                   allocated = ElemAllocVector[proc];
                   ElemAllocVector[proc] += ((sizeelem) / (sizeof (int) )) + (4);
                   if ((proc) == (pcxx_NodeNumber())) 
                   {
                      GlobalInfo.Table[GlobalIndex(i,j)] = allocated;
                      GlobalInfo.Where[GlobalIndex(i,j)] = (int *) 0;
                      if (ev_class&8) 
                      {
                         se_event(60160,GlobalIndex(i,j));
                       }
                     }
                    else{
                      GlobalInfo.Table[GlobalIndex(i,j)] = (int *) 0;
                      GlobalInfo.Where[GlobalIndex(i,j)] = allocated;
                    }
                 }
              }
           }
         }
       free(ElemAllocVector);
       _pcxx_Barrier();
       return 1;
}
 Kernel:: ~Kernel(){

       int found;
       int i,j;
       SetTableOfCollection(CollectionNumber,(char *) 0);
       delete  buffer;
       if ((GlobalInfo.number_dimension) == (1)) 
       {
          for (i = 0 ; (i) < (GlobalInfo.dim1size) ; (i)++)
          {
             if ((GlobalInfo.Table[GlobalIndex(i)])!=(0)) 
             {
                AweDealloc(GlobalInfo.Table[GlobalIndex(i)]);
                break;
              }
            }
        }
        else{
          if ((GlobalInfo.number_dimension) == (2)) 
          {
             found = 0;
             for (i = 0 ; ((i) < (GlobalInfo.dim1size)) && ( !(found)) ; (i)++)
             {
                for (j = 0 ; (j) < (GlobalInfo.dim2size) ; (j)++)
                {
                   if ((GlobalInfo.Table[GlobalIndex(i,j)])!=(0)) 
                   {
                      AweDealloc(GlobalInfo.Table[GlobalIndex(i,j)]);
                      found = 1;
                      break;
                    }
                  }
              }
           }
         }
       _pcxx_Barrier();
       free(GlobalInfo.Where);
       free(GlobalInfo.Table);
}
int  GetFirstLocalElementIndex(Kernel *p){

       Kernel  *pt;
       int i;
       pt = (Kernel *) p;
       for (i = 0 ; (i) < ((pt)->GlobalInfo.nb_element) ; (i)++)
       {
          if (((pt)->GlobalInfo.Table[i])!=(0)) 
          {
             return i;
           }
         }
       return  (-(1));
}
void   ResetLocal(Kernel *p){

       (p)->GlobalInfo.LocalTraversalCount = 0;
       SetNextCollectionTraversalLevel((char *) p);
}
int  Local(int elem){

       Kernel  *pt;
       int i;
       pt = (Kernel *) GetCollectionTraversalLevel();
       if (((pt)->GlobalInfo.LocalTraversalCount) >  ((pt)->GlobalInfo.nb_element)) 
       {
          DecCollectionTraversalLevel();
          return  (-(1));
        }
        for (i = (pt)->GlobalInfo.LocalTraversalCount ; (i) < ((pt)->GlobalInfo.nb_element) ; (i)++)
       {
          if (((pt)->GlobalInfo.Table[i])!=(0)) 
          {
             (pt)->GlobalInfo.LocalTraversalCount = (i) + (1);
             return i;
           }
         }
       DecCollectionTraversalLevel();
       return  (-(1));
}
int  FirstLocal(){

       return Local(0);
}
int  FirstInSubset(Kernel *coll, int lb, int ub, int step){

       if ( !(coll)) 
       {
          return  (-(1));
        }
        if ((lb) == ( (-(1)))) 
       {
          return 0;
        }
        if ((lb)<=(ub)) 
       {
          return lb;
        }
        return  (-(1));
}
int  NextInSubset(Kernel *coll, int lb, int ub, int step, int var){

       int bsup;
       if ( !(coll)) 
       {
          return  (-(1));
        }
        if ((ub) == ( (-(1)))) 
       {
          bsup = (coll)->GlobalInfo.dim1size;
        }
        else{
          bsup = ub;
        }
       if (((var) + (step))<=(bsup)) 
       {
          return (var) + (step);
        }
        else{
          return  (-(1));
        }
}
  CheckLocal(Kernel *coll, int index){

       if ( !(coll)) 
       {
          return 0;
        }
        return (coll)->Is_Local(index);
}
class  SuperKernel__Vector: public Kernel {
public:
       int dim1size;
       int dim2size;
        SuperKernel__Vector(Distribution *T, Align *A);
       Vector  *operator ()(int i1);
       Vector  *operator ()(int i1, int i2);
 
};
class  SuperKernel__SparseMatrix: public Kernel {
public:
       int dim1size;
       int dim2size;
        SuperKernel__SparseMatrix(Distribution *T, Align *A);
       SparseMatrix  *operator ()(int i1);
       SparseMatrix  *operator ()(int i1, int i2);
 
};
Vector * SuperKernel__Vector:: operator ()(int i1){

       Vector  *pt;
       pt = (Vector *) Get_Element(i1);
       return pt;
}
SparseMatrix * SuperKernel__SparseMatrix:: operator ()(int i1){

       SparseMatrix  *pt;
       pt = (SparseMatrix *) Get_Element(i1);
       return pt;
}
Vector * SuperKernel__Vector:: operator ()(int i1, int i2){

       Vector  *pt;
       pt = (Vector *) Get_Element(i1,i2);
       return pt;
}
SparseMatrix * SuperKernel__SparseMatrix:: operator ()(int i1, int i2){

       SparseMatrix  *pt;
       pt = (SparseMatrix *) Get_Element(i1,i2);
       return pt;
}
 SuperKernel__Vector:: SuperKernel__Vector(Distribution *T, Align *A):Kernel(T,A,sizeof (Vector) ){

       int i,j;
       if (( !(T)) || ( !(A))) 
       {
          Message("No alignment or template for collection initialization.",1);
        }
        dim1size = (A)->dim1size;
       dim2size = (A)->dim2size;
       if (((A)->nbdim) == (1)) 
       {
          for (i = 0 ; (i) < (dim1size) ; (i)++)
          {
             if (Is_Local(i)) 
             {
                ((*(this ))(i))->index1 = i;
                ((*(this ))(i))->index2 = 0;
                ((*(this ))(i))->ThisCollection = (SuperKernel__Vector *) this ;
                ((*(this ))(i))->Ident = (((this )->CollectionNumber) * (16777216)) + (i);
              }
            }
          _pcxx_Barrier();
        }
        if (((A)->nbdim) == (2)) 
       {
          for (i = 0 ; (i) < (dim1size) ; (i)++)
          {
             for (j = 0 ; (j) < (dim2size) ; (j)++)
             {
                if (Is_Local(i,j)) 
                {
                   ((*(this ))(i,j))->index1 = i;
                   ((*(this ))(i,j))->index2 = j;
                   ((*(this ))(i,j))->ThisCollection = (SuperKernel__Vector *) this ;
                   ((*(this ))(i))->Ident = ((((this )->CollectionNumber) * (16777216)) + (i)) + ((j) * ((this )->dim1size));
                 }
               }
           }
          _pcxx_Barrier();
        }
        if (((A)->nbdim)>=(3)) 
       {
          Message("3D and higher-dimensional collection not implemented.",1);
        }
 }
 SuperKernel__SparseMatrix:: SuperKernel__SparseMatrix(Distribution *T, Align *A):Kernel(T,A,sizeof (SparseMatrix) ){

       int i,j;
       if (( !(T)) || ( !(A))) 
       {
          Message("No alignment or template for collection initialization.",1);
        }
        dim1size = (A)->dim1size;
       dim2size = (A)->dim2size;
       if (((A)->nbdim) == (1)) 
       {
          for (i = 0 ; (i) < (dim1size) ; (i)++)
          {
             if (Is_Local(i)) 
             {
                ((*(this ))(i))->index1 = i;
                ((*(this ))(i))->index2 = 0;
                ((*(this ))(i))->ThisCollection = (SuperKernel__SparseMatrix *) this ;
                ((*(this ))(i))->Ident = (((this )->CollectionNumber) * (16777216)) + (i);
              }
            }
          _pcxx_Barrier();
        }
        if (((A)->nbdim) == (2)) 
       {
          for (i = 0 ; (i) < (dim1size) ; (i)++)
          {
             for (j = 0 ; (j) < (dim2size) ; (j)++)
             {
                if (Is_Local(i,j)) 
                {
                   ((*(this ))(i,j))->index1 = i;
                   ((*(this ))(i,j))->index2 = j;
                   ((*(this ))(i,j))->ThisCollection = (SuperKernel__SparseMatrix *) this ;
                   ((*(this ))(i))->Ident = ((((this )->CollectionNumber) * (16777216)) + (i)) + ((j) * ((this )->dim1size));
                 }
               }
           }
          _pcxx_Barrier();
        }
        if (((A)->nbdim)>=(3)) 
       {
          Message("3D and higher-dimensional collection not implemented.",1);
        }
 }
Vector * Vector:: Self(int i){

       return (Vector *) (ThisCollection)->Get_Element((index1) + (i));
}
SparseMatrix * SparseMatrix:: Self(int i){

       return (SparseMatrix *) (ThisCollection)->Get_Element((index1) + (i));
}
Vector * Vector:: Self(int i, int j){

       return (Vector *) (ThisCollection)->Get_Element((index1) + (i),(index2) + (j));
}
SparseMatrix * SparseMatrix:: Self(int i, int j){

       return (SparseMatrix *) (ThisCollection)->Get_Element((index1) + (i),(index2) + (j));
}
class  DistributedArray__Vector: public SuperKernel__Vector {
public:
       int blocksize;
        DistributedArray__Vector(Distribution *T, Align *A);
        DistributedArray__Vector(Kernel *coll);
       void  Assign(int i1, Vector &e);
       void  Assign(int i1, int i2, Vector &e);
       DistributedArray__Vector  &operator =(DistributedArray__Vector &rhs);
       void  Shift(int dim, int distance);
       void  Reduce();
       void  ReduceDim1();
       void  ReduceDim2();
       void  Broadcast();
       void  BroadcastDim1();
       void  BroadcastDim2();
       double DotProd(DistributedArray__Vector &arg1);
 
};
class  DistributedArray__SparseMatrix: public SuperKernel__SparseMatrix {
public:
       int blocksize;
        DistributedArray__SparseMatrix(Distribution *T, Align *A);
        DistributedArray__SparseMatrix(Kernel *coll);
       void  Assign(int i1, SparseMatrix &e);
       void  Assign(int i1, int i2, SparseMatrix &e);
       DistributedArray__SparseMatrix  &operator =(DistributedArray__SparseMatrix &rhs);
       void  Shift(int dim, int distance);
       void  Reduce();
       void  ReduceDim1();
       void  ReduceDim2();
       void  Broadcast();
       void  BroadcastDim1();
       void  BroadcastDim2();
       double DotProd(DistributedArray__SparseMatrix &arg1);
 
};
 DistributedArray__Vector:: DistributedArray__Vector(Distribution *T, Align *A):SuperKernel__Vector(T,A){

       if (( !(T)) || ( !(A))) 
       {
          Message("No alignment or template for collection initialization.",1);
        }
        blocksize = 0;
       ResetLocal(this );
       for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
       {
          pcxx_Poll();
          ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->Set_ThisCollection(this );
        }
       _pcxx_Barrier();
       if (((A)->nbdim)>=(3)) 
       {
          Message("3D and higher-dimensional DistributedArray not implemented.",1);
        }
 }
 DistributedArray__SparseMatrix:: DistributedArray__SparseMatrix(Distribution *T, Align *A):SuperKernel__SparseMatrix(T,A){

       if (( !(T)) || ( !(A))) 
       {
          Message("No alignment or template for collection initialization.",1);
        }
        blocksize = 0;
       ResetLocal(this );
       for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
       {
          pcxx_Poll();
          ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->Set_ThisCollection(this );
        }
       _pcxx_Barrier();
       if (((A)->nbdim)>=(3)) 
       {
          Message("3D and higher-dimensional DistributedArray not implemented.",1);
        }
 }
void  DistributedArray__Vector:: Shift(int dim, int distance){

       ResetLocal(this );
       for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
       {
          pcxx_Poll();
          ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->LocalShiftStep1(dim,distance);
        }
       _pcxx_Barrier();
       ResetLocal(this );
       for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
       {
          pcxx_Poll();
          ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->LocalShiftStep2();
        }
       _pcxx_Barrier();
       ResetLocal(this );
       for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
       {
          pcxx_Poll();
          ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->DeleteTemp();
        }
       _pcxx_Barrier();
}
void  DistributedArray__SparseMatrix:: Shift(int dim, int distance){

       ResetLocal(this );
       for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
       {
          pcxx_Poll();
          ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->LocalShiftStep1(dim,distance);
        }
       _pcxx_Barrier();
       ResetLocal(this );
       for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
       {
          pcxx_Poll();
          ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->LocalShiftStep2();
        }
       _pcxx_Barrier();
       ResetLocal(this );
       for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
       {
          pcxx_Poll();
          ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->DeleteTemp();
        }
       _pcxx_Barrier();
}
void  Vector:: LocalShiftStep1(int dim, int distance){

       int elem;
       Vector  *pt;
       double  *ptc,*pte;
       int i,size;
       if ((dim) == (1)) 
       {
          elem = (index1) + (distance);
          if ((elem)>=(0)) 
          {
             elem = (elem)% ((ThisCollection)->dim1size);
           }
           else{
             while ((elem) < (0))
             {
                elem = (elem) + ((ThisCollection)->dim1size);
              }
           }
          if ((ThisCollection)->Is_Local(elem,index2)) 
          {
             pt = (Vector *) (ThisCollection)->Get_Element(elem,index2);
             size = ((ThisCollection)->GlobalInfo.element_size) / (sizeof (double) );
             (this )->temporaryelement = (Vector *) new double [(size) + (1)] ;
             ptc = (double *) (this )->temporaryelement;
             pte = (double *) pt;
             for (i = 0 ; (i)<=(size) ; (i)++)
             {
                *((ptc)++) = *((pte)++);
              }
           }
           else{
             (this )->temporaryelement = (Vector *) (ThisCollection)->Get_CopyElem(elem,index2);
           }
        }
        else{
          elem = (index2) + (distance);
          if ((elem)>=(0)) 
          {
             elem = (elem)% ((ThisCollection)->dim2size);
           }
           else{
             while ((elem) < (0))
             {
                elem = (elem) + ((ThisCollection)->dim2size);
              }
           }
          if ((ThisCollection)->Is_Local(index1,elem)) 
          {
             pt = (Vector *) (ThisCollection)->Get_Element(index1,elem);
             size = ((ThisCollection)->GlobalInfo.element_size) / (sizeof (double) );
             (this )->temporaryelement = (Vector *) new double [(size) + (1)] ;
             ptc = (double *) (this )->temporaryelement;
             pte = (double *) pt;
             for (i = 0 ; (i)<=(size) ; (i)++)
             {
                *((ptc)++) = *((pte)++);
              }
           }
           else{
             (this )->temporaryelement = (Vector *) (ThisCollection)->Get_CopyElem(index1,elem);
           }
        }
}
void  SparseMatrix:: LocalShiftStep1(int dim, int distance){

       int elem;
       SparseMatrix  *pt;
       double  *ptc,*pte;
       int i,size;
       if ((dim) == (1)) 
       {
          elem = (index1) + (distance);
          if ((elem)>=(0)) 
          {
             elem = (elem)% ((ThisCollection)->dim1size);
           }
           else{
             while ((elem) < (0))
             {
                elem = (elem) + ((ThisCollection)->dim1size);
              }
           }
          if ((ThisCollection)->Is_Local(elem,index2)) 
          {
             pt = (SparseMatrix *) (ThisCollection)->Get_Element(elem,index2);
             size = ((ThisCollection)->GlobalInfo.element_size) / (sizeof (double) );
             (this )->temporaryelement = (SparseMatrix *) new double [(size) + (1)] ;
             ptc = (double *) (this )->temporaryelement;
             pte = (double *) pt;
             for (i = 0 ; (i)<=(size) ; (i)++)
             {
                *((ptc)++) = *((pte)++);
              }
           }
           else{
             (this )->temporaryelement = (SparseMatrix *) (ThisCollection)->Get_CopyElem(elem,index2);
           }
        }
        else{
          elem = (index2) + (distance);
          if ((elem)>=(0)) 
          {
             elem = (elem)% ((ThisCollection)->dim2size);
           }
           else{
             while ((elem) < (0))
             {
                elem = (elem) + ((ThisCollection)->dim2size);
              }
           }
          if ((ThisCollection)->Is_Local(index1,elem)) 
          {
             pt = (SparseMatrix *) (ThisCollection)->Get_Element(index1,elem);
             size = ((ThisCollection)->GlobalInfo.element_size) / (sizeof (double) );
             (this )->temporaryelement = (SparseMatrix *) new double [(size) + (1)] ;
             ptc = (double *) (this )->temporaryelement;
             pte = (double *) pt;
             for (i = 0 ; (i)<=(size) ; (i)++)
             {
                *((ptc)++) = *((pte)++);
              }
           }
           else{
             (this )->temporaryelement = (SparseMatrix *) (ThisCollection)->Get_CopyElem(index1,elem);
           }
        }
}
void  Vector:: LocalShiftStep2(){

       *(this ) = *((this )->temporaryelement);
}
void  SparseMatrix:: LocalShiftStep2(){

       *(this ) = *((this )->temporaryelement);
}
void  Vector:: DeleteTemp(){

       delete  (this )->temporaryelement;
       (this )->temporaryelement = 0;
}
void  SparseMatrix:: DeleteTemp(){

       delete  (this )->temporaryelement;
       (this )->temporaryelement = 0;
}
void  Vector:: Set_ThisCollection(DistributedArray__Vector *C){

       (this )->ThisCollection = C;
}
void  SparseMatrix:: Set_ThisCollection(DistributedArray__SparseMatrix *C){

       (this )->ThisCollection = C;
}
void  Vector:: WhereAmI(){

       printf("Element (%d, %d) on processor %d\n",index1,index2,pcxx_NodeNumber());
       _pcxx_Barrier();
}
void  SparseMatrix:: WhereAmI(){

       printf("Element (%d, %d) on processor %d\n",index1,index2,pcxx_NodeNumber());
       _pcxx_Barrier();
}
void  DistributedArray__Vector:: Assign(int i1, Vector &e){

       if ((this )->Is_Local(i1)) 
       {
          *((*(this ))(i1)) = e;
        }
 }
void  DistributedArray__SparseMatrix:: Assign(int i1, SparseMatrix &e){

       if ((this )->Is_Local(i1)) 
       {
          *((*(this ))(i1)) = e;
        }
 }
void  DistributedArray__Vector:: Assign(int i1, int i2, Vector &e){

       if ((this )->Is_Local(i1,i2)) 
       {
          *((*(this ))(i1,i2)) = e;
        }
 }
void  DistributedArray__SparseMatrix:: Assign(int i1, int i2, SparseMatrix &e){

       if ((this )->Is_Local(i1,i2)) 
       {
          *((*(this ))(i1,i2)) = e;
        }
 }
void  DistributedArray__Vector:: Reduce(){

       int steps = 1;
       int borne;
       if (dim2size) 
       {
          borne = (dim1size) * (dim2size);
        }
        else{
          borne = dim1size;
        }
       while ((steps) < (borne))
       {
          ResetLocal(this );
          for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
          {
             pcxx_Poll();
             ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->LocalReduce(this ,steps);
           }
          _pcxx_Barrier();
          steps = (steps) * (2);
        }
}
void  DistributedArray__SparseMatrix:: Reduce(){

       int steps = 1;
       int borne;
       if (dim2size) 
       {
          borne = (dim1size) * (dim2size);
        }
        else{
          borne = dim1size;
        }
       while ((steps) < (borne))
       {
          ResetLocal(this );
          for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
          {
             pcxx_Poll();
             ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->LocalReduce(this ,steps);
           }
          _pcxx_Barrier();
          steps = (steps) * (2);
        }
}
void  DistributedArray__Vector:: ReduceDim1(){

       int steps = 1;
       while ((steps) < (dim1size))
       {
          ResetLocal(this );
          for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
          {
             pcxx_Poll();
             ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->LocalReduceDim1(this ,steps);
           }
          _pcxx_Barrier();
          steps = (steps) * (2);
        }
}
void  DistributedArray__SparseMatrix:: ReduceDim1(){

       int steps = 1;
       while ((steps) < (dim1size))
       {
          ResetLocal(this );
          for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
          {
             pcxx_Poll();
             ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->LocalReduceDim1(this ,steps);
           }
          _pcxx_Barrier();
          steps = (steps) * (2);
        }
}
void  DistributedArray__Vector:: ReduceDim2(){

       int steps = 1;
       while ((steps) < (dim2size))
       {
          ResetLocal(this );
          for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
          {
             pcxx_Poll();
             ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->LocalReduceDim2(this ,steps);
           }
          _pcxx_Barrier();
          steps = (steps) * (2);
        }
}
void  DistributedArray__SparseMatrix:: ReduceDim2(){

       int steps = 1;
       while ((steps) < (dim2size))
       {
          ResetLocal(this );
          for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
          {
             pcxx_Poll();
             ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->LocalReduceDim2(this ,steps);
           }
          _pcxx_Barrier();
          steps = (steps) * (2);
        }
}
void  Vector:: LocalReduce(DistributedArray__Vector *array, int step){

       int ind;
       ind = (ThisCollection)->GlobalIndex(index1,index2);
       if (((ind)% ((2) * (step))) == (0)) 
       {
          *(this ) += *((*(array))((ind) + (step)));
        }
 }
void  SparseMatrix:: LocalReduce(DistributedArray__SparseMatrix *array, int step){

       int ind;
       ind = (ThisCollection)->GlobalIndex(index1,index2);
       if (((ind)% ((2) * (step))) == (0)) 
       {
          *(this ) += *((*(array))((ind) + (step)));
        }
 }
void  Vector:: LocalReduceDim1(DistributedArray__Vector *array, int step){

       if (((index1)% ((2) * (step))) == (0)) 
       {
          *(this ) += *((*(array))((index1) + (step),index2));
        }
 }
void  SparseMatrix:: LocalReduceDim1(DistributedArray__SparseMatrix *array, int step){

       if (((index1)% ((2) * (step))) == (0)) 
       {
          *(this ) += *((*(array))((index1) + (step),index2));
        }
 }
void  Vector:: LocalReduceDim2(DistributedArray__Vector *array, int step){

       if (((index2)% ((2) * (step))) == (0)) 
       {
          *(this ) += *((*(array))(index1,(index2) + (step)));
        }
 }
void  SparseMatrix:: LocalReduceDim2(DistributedArray__SparseMatrix *array, int step){

       if (((index2)% ((2) * (step))) == (0)) 
       {
          *(this ) += *((*(array))(index1,(index2) + (step)));
        }
 }
void  DistributedArray__Vector:: Broadcast(){

       int steps;
       if (dim2size) 
       {
          steps = ((dim1size) * (dim2size)) / (2);
        }
        else{
          steps = (dim1size) / (2);
        }
       while (steps)
       {
          ResetLocal(this );
          for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
          {
             pcxx_Poll();
             ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->LocalBroadcast(this ,steps);
           }
          _pcxx_Barrier();
          if ((steps) == (1)) 
          {
             break;
           }
           steps = (steps) / (2);
        }
}
void  DistributedArray__SparseMatrix:: Broadcast(){

       int steps;
       if (dim2size) 
       {
          steps = ((dim1size) * (dim2size)) / (2);
        }
        else{
          steps = (dim1size) / (2);
        }
       while (steps)
       {
          ResetLocal(this );
          for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
          {
             pcxx_Poll();
             ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->LocalBroadcast(this ,steps);
           }
          _pcxx_Barrier();
          if ((steps) == (1)) 
          {
             break;
           }
           steps = (steps) / (2);
        }
}
void  DistributedArray__Vector:: BroadcastDim1(){

       int steps = (dim1size) / (2);
       while (steps)
       {
          ResetLocal(this );
          for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
          {
             pcxx_Poll();
             ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->LocalBroadcastDim1(this ,steps);
           }
          _pcxx_Barrier();
          if ((steps) == (1)) 
          {
             break;
           }
           steps = (steps) / (2);
        }
}
void  DistributedArray__SparseMatrix:: BroadcastDim1(){

       int steps = (dim1size) / (2);
       while (steps)
       {
          ResetLocal(this );
          for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
          {
             pcxx_Poll();
             ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->LocalBroadcastDim1(this ,steps);
           }
          _pcxx_Barrier();
          if ((steps) == (1)) 
          {
             break;
           }
           steps = (steps) / (2);
        }
}
void  DistributedArray__Vector:: BroadcastDim2(){

       int steps = (dim2size) / (2);
       while (steps)
       {
          ResetLocal(this );
          for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
          {
             pcxx_Poll();
             ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->LocalBroadcastDim2(this ,steps);
           }
          _pcxx_Barrier();
          if ((steps) == (1)) 
          {
             break;
           }
           steps = (steps) / (2);
        }
}
void  DistributedArray__SparseMatrix:: BroadcastDim2(){

       int steps = (dim2size) / (2);
       while (steps)
       {
          ResetLocal(this );
          for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
          {
             pcxx_Poll();
             ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->LocalBroadcastDim2(this ,steps);
           }
          _pcxx_Barrier();
          if ((steps) == (1)) 
          {
             break;
           }
           steps = (steps) / (2);
        }
}
void  Vector:: LocalBroadcast(DistributedArray__Vector *array, int step){

       int ind;
       ind = (ThisCollection)->GlobalIndex(index1,index2);
       if (((ind) && (((ind)% (step)) == (0))) && ( !(((ind)% ((2) * (step))) == (0)))) 
       {
          *(this ) = *((*(array))((ind) -(step)));
        }
 }
void  SparseMatrix:: LocalBroadcast(DistributedArray__SparseMatrix *array, int step){

       int ind;
       ind = (ThisCollection)->GlobalIndex(index1,index2);
       if (((ind) && (((ind)% (step)) == (0))) && ( !(((ind)% ((2) * (step))) == (0)))) 
       {
          *(this ) = *((*(array))((ind) -(step)));
        }
 }
void  Vector:: LocalBroadcastDim1(DistributedArray__Vector *array, int step){

       if (((index1) && (((index1)% (step)) == (0))) && ( !(((index1)% ((2) * (step))) == (0)))) 
       {
          *(this ) = *((*(array))((index1) -(step),index2));
        }
 }
void  SparseMatrix:: LocalBroadcastDim1(DistributedArray__SparseMatrix *array, int step){

       if (((index1) && (((index1)% (step)) == (0))) && ( !(((index1)% ((2) * (step))) == (0)))) 
       {
          *(this ) = *((*(array))((index1) -(step),index2));
        }
 }
void  Vector:: LocalBroadcastDim2(DistributedArray__Vector *array, int step){

       if (((index2) && (((index2)% (step)) == (0))) && ( !(((index2)% ((2) * (step))) == (0)))) 
       {
          *(this ) = *((*(array))(index1,(index2) -(step)));
        }
 }
void  SparseMatrix:: LocalBroadcastDim2(DistributedArray__SparseMatrix *array, int step){

       if (((index2) && (((index2)% (step)) == (0))) && ( !(((index2)% ((2) * (step))) == (0)))) 
       {
          *(this ) = *((*(array))(index1,(index2) -(step)));
        }
 }
DistributedArray__Vector & DistributedArray__Vector:: operator =(DistributedArray__Vector &rhs){

       ResetLocal(this );
       for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
       {
          pcxx_Poll();
          ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->LocalCopy(&(rhs));
        }
       _pcxx_Barrier();
       return *(this );
}
DistributedArray__SparseMatrix & DistributedArray__SparseMatrix:: operator =(DistributedArray__SparseMatrix &rhs){

       ResetLocal(this );
       for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
       {
          pcxx_Poll();
          ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->LocalCopy(&(rhs));
        }
       _pcxx_Barrier();
       return *(this );
}
void  Vector:: LocalCopy(DistributedArray__Vector *array){

       *(this ) = *((*(array))(index1,index2));
}
void  SparseMatrix:: LocalCopy(DistributedArray__SparseMatrix *array){

       *(this ) = *((*(array))(index1,index2));
}
double DistributedArray__Vector:: DotProd(DistributedArray__Vector &arg1){

       double total;
       int steps = 1;
       int locali;
       Vector dummy;
       int  *addr1,*addr2;
       int borne;
       double  *tmp;
       ResetLocal(this );
       for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
       {
          pcxx_Poll();
          ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->ResetDotProd(arg1);
        }
       _pcxx_Barrier();
       borne = dim1size;
       if (dim2size) 
       {
          borne = (borne) * (dim2size);
        }
        while ((steps) < (borne))
       {
          ResetLocal(this );
          for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
          {
             pcxx_Poll();
             ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->LocalGSum(*(this ),steps);
           }
          _pcxx_Barrier();
          steps = (steps) * (2);
        }
       if (dim2size) 
       {
          steps = ((dim1size) * (dim2size)) / (2);
        }
        else{
          steps = (dim1size) / (2);
        }
       while (steps)
       {
          ResetLocal(this );
          for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
          {
             pcxx_Poll();
             ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->BroadcastTemp(*(this ),steps);
           }
          _pcxx_Barrier();
          if ((steps) == (1)) 
          {
             break;
           }
           steps = (steps) / (2);
        }
       locali = GetFirstLocalElementIndex(this );
       if ((locali)>=(0)) 
       {
          total = ((*(this ))(locali))->dotprodtemp;
        }
        else{
          addr1 = (int *) &(dummy);
          addr2 = (int *) &(dummy.dotprodtemp);
          tmp = (double *) (this )->Get_ElementPart((pcxx_NodeNumber())% ((this )->dim1size),(addr2) -(addr1),(sizeof (double) ) / (sizeof (int) ));
          total = *(tmp);
        }
       _pcxx_Barrier();
       return total;
}
double DistributedArray__SparseMatrix:: DotProd(DistributedArray__SparseMatrix &arg1){

       double total;
       int steps = 1;
       int locali;
       SparseMatrix dummy;
       int  *addr1,*addr2;
       int borne;
       double  *tmp;
       ResetLocal(this );
       for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
       {
          pcxx_Poll();
          ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->ResetDotProd(arg1);
        }
       _pcxx_Barrier();
       borne = dim1size;
       if (dim2size) 
       {
          borne = (borne) * (dim2size);
        }
        while ((steps) < (borne))
       {
          ResetLocal(this );
          for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
          {
             pcxx_Poll();
             ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->LocalGSum(*(this ),steps);
           }
          _pcxx_Barrier();
          steps = (steps) * (2);
        }
       if (dim2size) 
       {
          steps = ((dim1size) * (dim2size)) / (2);
        }
        else{
          steps = (dim1size) / (2);
        }
       while (steps)
       {
          ResetLocal(this );
          for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
          {
             pcxx_Poll();
             ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->BroadcastTemp(*(this ),steps);
           }
          _pcxx_Barrier();
          if ((steps) == (1)) 
          {
             break;
           }
           steps = (steps) / (2);
        }
       locali = GetFirstLocalElementIndex(this );
       if ((locali)>=(0)) 
       {
          total = ((*(this ))(locali))->dotprodtemp;
        }
        else{
          addr1 = (int *) &(dummy);
          addr2 = (int *) &(dummy.dotprodtemp);
          tmp = (double *) (this )->Get_ElementPart((pcxx_NodeNumber())% ((this )->dim1size),(addr2) -(addr1),(sizeof (double) ) / (sizeof (int) ));
          total = *(tmp);
        }
       _pcxx_Barrier();
       return total;
}
void  Vector:: LocalGSum(DistributedArray__Vector &array, int step){

       int ind;
       ind = (ThisCollection)->GlobalIndex(index1,index2);
       if (((ind)% ((2) * (step))) == (0)) 
       {
          int  *addr1,*addr2;
          double  *tmp;
          Vector  *x;
          addr1 = (int *) this ;
          addr2 = (int *) &((this )->dotprodtemp);
          tmp = (double *) array.Get_ElementPart((ind) + (step),(addr2) -(addr1),(sizeof (double) ) / (sizeof (int) ));
          dotprodtemp += *(tmp);
        }
 }
void  SparseMatrix:: LocalGSum(DistributedArray__SparseMatrix &array, int step){

       int ind;
       ind = (ThisCollection)->GlobalIndex(index1,index2);
       if (((ind)% ((2) * (step))) == (0)) 
       {
          int  *addr1,*addr2;
          double  *tmp;
          SparseMatrix  *x;
          addr1 = (int *) this ;
          addr2 = (int *) &((this )->dotprodtemp);
          tmp = (double *) array.Get_ElementPart((ind) + (step),(addr2) -(addr1),(sizeof (double) ) / (sizeof (int) ));
          dotprodtemp += *(tmp);
        }
 }
void  Vector:: BroadcastTemp(DistributedArray__Vector &array, int step){

       int ind;
       ind = (ThisCollection)->GlobalIndex(index1,index2);
       if (((ind) && (((ind)% (step)) == (0))) && ( !(((ind)% ((2) * (step))) == (0)))) 
       {
          int  *addr1,*addr2;
          double  *tmp;
          Vector  *x;
          addr1 = (int *) this ;
          addr2 = (int *) &((this )->dotprodtemp);
          tmp = (double *) array.Get_ElementPart((ind) -(step),(addr2) -(addr1),(sizeof (double) ) / (sizeof (int) ));
          (this )->dotprodtemp = *(tmp);
        }
 }
void  SparseMatrix:: BroadcastTemp(DistributedArray__SparseMatrix &array, int step){

       int ind;
       ind = (ThisCollection)->GlobalIndex(index1,index2);
       if (((ind) && (((ind)% (step)) == (0))) && ( !(((ind)% ((2) * (step))) == (0)))) 
       {
          int  *addr1,*addr2;
          double  *tmp;
          SparseMatrix  *x;
          addr1 = (int *) this ;
          addr2 = (int *) &((this )->dotprodtemp);
          tmp = (double *) array.Get_ElementPart((ind) -(step),(addr2) -(addr1),(sizeof (double) ) / (sizeof (int) ));
          (this )->dotprodtemp = *(tmp);
        }
 }
void  Vector:: ResetDotProd(DistributedArray__Vector &arg1){

       dotprodtemp = (this )->Dot(*((arg1)(index1,index2)));
}
void  SparseMatrix:: ResetDotProd(DistributedArray__SparseMatrix &arg1){

       dotprodtemp = (this )->Dot(*((arg1)(index1,index2)));
}
class  NewDistArray__Vector: public DistributedArray__Vector {
public:
        NewDistArray__Vector(Distribution *T, Align *A);
       void  Set_Block_Size(int size);
 
};
 NewDistArray__Vector:: NewDistArray__Vector(Distribution *T, Align *A):DistributedArray__Vector(T,A){

}
void  NewDistArray__Vector:: Set_Block_Size(int size){

       blocksize = size;
       ResetLocal(this );
       for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
       {
          pcxx_Poll();
          ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->allocData(size);
        }
       _pcxx_Barrier();
}
class  DistBlkVector__Vector: public DistributedArray__Vector {
public:
       int elem_per_block;
       int add_to_elem;
        DistBlkVector__Vector(Distribution *T, Align *A, int blksize, int initval);
        DistBlkVector__Vector(Distribution *T, Align *A, int blksize);
       double  &operator [](int i);
       void  operator =(DistBlkVector__Vector &rhs);
       void  Copy(DistBlkVector__Vector *rhs);
       void  setValue(int i, double value);
       void  print();
       int LocalElem(int i);
       double gnorm();
       double dotprod(DistBlkVector__Vector &arg1);
       double specialmax(double zeta);
       void  alloc_elements(int inival);
       void  SetFirstRow(NewDistArray__Vector &array);
 
};
void  DistBlkVector__Vector:: alloc_elements(int inival){

       ResetLocal(this );
       for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
       {
          pcxx_Poll();
          ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->allocData((this )->blocksize,inival);
        }
       _pcxx_Barrier();
       ResetLocal(this );
       for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
       {
          pcxx_Poll();
          ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->init_elem((this )->blocksize,elem_per_block,add_to_elem,dim1size);
        }
       _pcxx_Barrier();
}
void  Vector:: sub(DistBlkVector__Vector &arg1, DistBlkVector__Vector &arg2){

       (this )->sub_el(*((arg1)(index1)),*((arg2)(index1)));
}
void  Vector:: add(DistBlkVector__Vector &arg1, DistBlkVector__Vector &arg2){

       (this )->add_el(*((arg1)(index1)),*((arg2)(index1)));
}
void  Vector:: mul(DistBlkVector__Vector &arg1, DistBlkVector__Vector &arg2){

       (this )->mul_el(*((arg1)(index1)),*((arg2)(index1)));
}
void  Vector:: asgn(DistBlkVector__Vector &arg1){

       (this )->asgn_el(*((arg1)(index1)));
}
void  Vector:: pasgn(DistBlkVector__Vector &arg1){

       (this )->pasgn_el(*((arg1)(index1)));
}
void  Vector:: masgn(DistBlkVector__Vector &arg1){

       (this )->masgn_el(*((arg1)(index1)));
}
void  Vector:: saxpy(double s, DistBlkVector__Vector &arg1, DistBlkVector__Vector &arg2){

       (this )->saxpy_el(s,*((arg1)(index1)),*((arg2)(index1)));
}
void  Vector:: asgnm(double s, DistBlkVector__Vector &arg1){

       (this )->asgnm_el(s,*((arg1)(index1)));
}
void  Vector:: ResetDotProd(DistBlkVector__Vector &arg1){

       dot_temp = (this )->Dot(*((arg1)(index1)));
}
void  Vector:: Resetspecialmax(double zeta){

       dot_temp = (this )->smax(zeta);
}
double DistBlkVector__Vector:: dotprod(DistBlkVector__Vector &arg1){

       double total;
       int steps = 1;
       int locali;
       Vector dummy(0);
       int  *addr1,*addr2;
       double  *tmp;
       ResetLocal(this );
       for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
       {
          pcxx_Poll();
          ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->ResetDotProd(arg1);
        }
       _pcxx_Barrier();
       while ((steps) < (dim1size))
       {
          ResetLocal(this );
          for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
          {
             pcxx_Poll();
             ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->gsum(*(this ),steps);
           }
          _pcxx_Barrier();
          steps = (steps) * (2);
        }
       steps = (dim1size) / (2);
       while (steps)
       {
          ResetLocal(this );
          for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
          {
             pcxx_Poll();
             ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->LocalBroadcast(*(this ),steps);
           }
          _pcxx_Barrier();
          if ((steps) == (1)) 
          {
             break;
           }
           steps = (steps) / (2);
        }
       locali = GetFirstLocalElementIndex(this );
       if ((locali)>=(0)) 
       {
          total = ((*(this ))(locali))->dot_temp;
        }
        else{
          addr1 = (int *) &(dummy);
          addr2 = (int *) &(dummy.dot_temp);
          tmp = (double *) (this )->Get_ElementPart((pcxx_NodeNumber())% ((this )->dim1size),(addr2) -(addr1),(sizeof (double) ) / (sizeof (int) ));
          total = *(tmp);
        }
       _pcxx_Barrier();
       return total;
}
double DistBlkVector__Vector:: specialmax(double zeta){

       double total;
       int steps = 1;
       int locali;
       Vector dummy(0);
       int  *addr1,*addr2;
       double  *tmp;
       ResetLocal(this );
       for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
       {
          pcxx_Poll();
          ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->Resetspecialmax(zeta);
        }
       _pcxx_Barrier();
       while ((steps) < (dim1size))
       {
          ResetLocal(this );
          for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
          {
             pcxx_Poll();
             ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->gmaxs(zeta,steps);
           }
          _pcxx_Barrier();
          steps = (steps) * (2);
        }
       steps = (dim1size) / (2);
       while (steps)
       {
          ResetLocal(this );
          for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
          {
             pcxx_Poll();
             ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->LocalBroadcast(*(this ),steps);
           }
          _pcxx_Barrier();
          if ((steps) == (1)) 
          {
             break;
           }
           steps = (steps) / (2);
        }
       locali = GetFirstLocalElementIndex(this );
       if ((locali)>=(0)) 
       {
          total = ((*(this ))(locali))->dot_temp;
        }
        else{
          addr1 = (int *) &(dummy);
          addr2 = (int *) &(dummy.dot_temp);
          tmp = (double *) (this )->Get_ElementPart((pcxx_NodeNumber())% ((this )->dim1size),(addr2) -(addr1),(sizeof (double) ) / (sizeof (int) ));
          total = *(tmp);
        }
       _pcxx_Barrier();
       return total;
}
void  Vector:: LocalBroadcast(DistBlkVector__Vector &array, int step){

       int ind;
       ind = index1;
       if (((ind) && (((ind)% (step)) == (0))) && ( !(((ind)% ((2) * (step))) == (0)))) 
       {
          int  *addr1,*addr2;
          double  *tmp;
          Vector  *x;
          addr1 = (int *) this ;
          addr2 = (int *) &((this )->dot_temp);
          tmp = (double *) array.Get_ElementPart((ind) -(step),(addr2) -(addr1),(sizeof (double) ) / (sizeof (int) ));
          (this )->dot_temp = *(tmp);
        }
 }
void  Vector:: gsum(DistBlkVector__Vector &array, int step){

       if (((index1)% ((2) * (step))) == (0)) 
       {
          int  *addr1,*addr2;
          double  *tmp;
          Vector  *x;
          addr1 = (int *) this ;
          addr2 = (int *) &((this )->dot_temp);
          tmp = (double *) array.Get_ElementPart((index1) + (step),(addr2) -(addr1),(sizeof (double) ) / (sizeof (int) ));
          dot_temp += *(tmp);
        }
 }
void  Vector:: gmaxs(double zeta, int step){

       if (((index1)% ((2) * (step))) == (0)) 
       {
          int  *addr1,*addr2;
          double  *tmp;
          Vector  *x;
          addr1 = (int *) this ;
          addr2 = (int *) &((this )->dot_temp);
          tmp = (double *) (ThisCollection)->Get_ElementPart((index1) + (step),(addr2) -(addr1),(sizeof (double) ) / (sizeof (int) ));
          if ((*(tmp)) >  (dot_temp)) 
          {
             dot_temp = *(tmp);
           }
         }
 }
double DistBlkVector__Vector:: gnorm(){

       return sqrt(dotprod(*(this )));
}
 DistBlkVector__Vector:: DistBlkVector__Vector(Distribution *T, Align *A, int blksize, int initval):DistributedArray__Vector(T,A){

       int j;
       int tmp;
       elem_per_block = (blksize) / (dim1size);
       add_to_elem = (blksize) -((elem_per_block) * (dim1size));
       blocksize = blksize;
       ResetLocal(this );
       for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
       {
          pcxx_Poll();
          ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->allocData(blocksize,initval);
        }
       _pcxx_Barrier();
       for (j = 0 ; (j) < (dim1size) ; (j)++)
       {
          if ((this )->Is_Local(j)) 
          {
             ((*(this ))(j))->index1 = j;
           }
         }
       _pcxx_Barrier();
}
 DistBlkVector__Vector:: DistBlkVector__Vector(Distribution *T, Align *A, int blksize):DistributedArray__Vector(T,A){

       int j;
       int tmp;
       elem_per_block = (blksize) / (dim1size);
       blocksize = blksize;
       add_to_elem = (blksize) -((elem_per_block) * (dim1size));
       ResetLocal(this );
       for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
       {
          pcxx_Poll();
          ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->allocData(blocksize);
        }
       _pcxx_Barrier();
       for (j = 0 ; (j) < (dim1size) ; (j)++)
       {
          if ((this )->Is_Local(j)) 
          {
             ((*(this ))(j))->index1 = j;
           }
         }
       _pcxx_Barrier();
}
void  Vector:: TakeFirstCol(NewDistArray__Vector &array){

       Vector  *tmp;
       int i;
       int si,rem,s;
       int  *addr1,*addr2;
       double  *buf;
       addr1 = (int *) this ;
       addr2 = (int *) &((this )->data[0]);
       buf = (double *) array.Get_ElementPart(0,index1,(addr2) -(addr1),((this )->size) * ((sizeof (double) ) / (sizeof (int) )));
       for (i = 0 ; (i) < ((this )->size) ; (i)++)
       {
          (this )->data[i] = *(buf);
          (buf)++;
        }
       for (i = (this )->size ; (i) < (((1400) / (8)) + (4)) ; (i)++)
       {
          (this )->data[i] = 0;
        }
}
void  DistBlkVector__Vector:: SetFirstRow(NewDistArray__Vector &array){

       int i,j;
       for (i = 0 ; (i) < (array.dim2size) ; (i)++)
       {
          if (array.Is_Local(i,0)) 
          {
             *((array)(i,0)) = *((*(this ))(i));
           }
         }
       _pcxx_Barrier();
}
double & DistBlkVector__Vector:: operator [](int position){

       int j,k,i;
       i = ComputeMyBlock(elem_per_block,add_to_elem,position);
       j = ComputeMyIndexInBlock(elem_per_block,add_to_elem,position);
       i = (position) / (elem_per_block);
       return ((*(this ))(i))->data[j];
}
int DistBlkVector__Vector:: LocalElem(int ii){

       int j,k,i;
       j = ComputeMyBlock(elem_per_block,add_to_elem,ii);
       return (this )->Is_Local(j);
}
void  Vector:: CopyElem(DistBlkVector__Vector *v){

       *(this ) = *((*(v))(index1));
}
void  DistBlkVector__Vector:: Copy(DistBlkVector__Vector *rhs){

       ResetLocal(this );
       for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
       {
          pcxx_Poll();
          ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->CopyElem(rhs);
        }
       _pcxx_Barrier();
}
void  DistBlkVector__Vector:: operator =(DistBlkVector__Vector &rhs){

       (this )->Copy(&(rhs));
}
void  DistBlkVector__Vector:: setValue(int i, double value){

       int j,k;
       double  *p;
       j = ComputeMyBlock(elem_per_block,add_to_elem,i);
       k = ComputeMyIndexInBlock(elem_per_block,add_to_elem,i);
       if ((this )->Is_Local(j)) 
       {
          p = &(((*(this ))(j))->data[k]);
          *(p) = value;
        }
        _pcxx_Barrier();
}
class  DistBlkMatrix__SparseMatrix: public DistributedArray__SparseMatrix {
public:
       int rows,cols;
       int p,cols_per_elem,add_to_elem;
        DistBlkMatrix__SparseMatrix(Distribution *T, Align *A, int r, int c);
       void  MatVec(DistBlkVector__Vector &vectout, DistBlkVector__Vector &vectin, NewDistArray__Vector &tmp);
       int LocalElem(int i);
       double getvalue(int r, int c);
       void  setvalue(int r, int c, double v);
       void  setplusvalue(int r, int c, double v);
       void  init();
       void  Broadcast();
 
};
void  DistBlkMatrix__SparseMatrix:: Broadcast(){

       int steps;
       steps = ((dim1size) * (dim2size)) / (2);
       while (steps)
       {
          ResetLocal(this );
          for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
          {
             pcxx_Poll();
             ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->LocalBroadcast(steps);
           }
          _pcxx_Barrier();
          if ((steps) == (1)) 
          {
             break;
           }
           steps = (steps) / (2);
        }
}
void  SparseMatrix:: LocalBroadcast(int step){

       int ind;
       ind = (ThisCollection)->GlobalIndex(index1,index2);
       if (((ind) && (((ind)% (step)) == (0))) && ( !(((ind)% ((2) * (step))) == (0)))) 
       {
          (this )->tempforgetvalue = ((*(ThisCollection))((ind) -(step)))->tempforgetvalue;
        }
 }
void  DistBlkMatrix__SparseMatrix:: init(){

       int i,j,rr,cc;
       SparseMatrix  *e;
       for (i = 0 ; (i) < (dim1size) ; (i)++)
       {
          for (j = 0 ; (j) < (dim2size) ; (j)++)
          {
             if ((this )->Is_Local(i,j)) 
             {
                e = (SparseMatrix *) Get_Element(i,j);
                if ((i) < (add_to_elem)) 
                {
                   cc = (cols_per_elem) + (1);
                 }
                 else{
                   cc = cols_per_elem;
                 }
                if ((j) < (add_to_elem)) 
                {
                   rr = (cols_per_elem) + (1);
                 }
                 else{
                   rr = cols_per_elem;
                 }
                (e)->initialize(rr,cc,(dim1size) * (dim2size));
              }
            }
        }
       _pcxx_Barrier();
       if ((pcxx_NodeNumber()) == (0)) 
       {
          printf("Matrix Allocated \n");
        }
 }
 DistBlkMatrix__SparseMatrix:: DistBlkMatrix__SparseMatrix(Distribution *T, Align *A, int r, int c):DistributedArray__SparseMatrix(T,A){

       int i,j;
       blocksize = 0;
       rows = r;
       cols = c;
       p = dim1size;
       cols_per_elem = (c) / (p);
       add_to_elem = (c) -((cols_per_elem) * (dim1size));
       for (i = 0 ; (i) < (dim1size) ; (i)++)
       {
          for (j = 0 ; (j) < (dim2size) ; (j)++)
          {
             if ((this )->Is_Local(i,j)) 
             {
                ((*(this ))(i,j))->index1 = i;
                ((*(this ))(i,j))->index2 = j;
              }
            }
        }
       _pcxx_Barrier();
}
int DistBlkMatrix__SparseMatrix:: LocalElem(int i){

       int n1;
       n1 = (i) / (blocksize);
       return (this )->Is_Local(n1);
}
void  SparseMatrix:: LocalMatVect(NewDistArray__Vector &tmp){

       (this )->amux(*((tmp)(index1,index2)),*((tmp)(index1,index2)));
}
void  DistBlkMatrix__SparseMatrix:: MatVec(DistBlkVector__Vector &vectout, DistBlkVector__Vector &vectin, NewDistArray__Vector &tmp){

       pcxx_UserTimerStart(2);
       vectin.SetFirstRow(tmp);
       pcxx_UserTimerStop(2);
       pcxx_UserTimerStart(3);
       tmp.BroadcastDim2();
       pcxx_UserTimerStop(3);
       pcxx_UserTimerStart(4);
       ResetLocal(this );
       for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
       {
          pcxx_Poll();
          ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->LocalMatVect(tmp);
        }
       _pcxx_Barrier();
       pcxx_UserTimerStop(4);
       pcxx_UserTimerStart(5);
       tmp.ReduceDim1();
       pcxx_UserTimerStop(5);
       pcxx_UserTimerStart(6);
       ResetLocal(&(vectout));
       for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
       {
          pcxx_Poll();
          ((vectout)((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->TakeFirstCol(tmp);
        }
       _pcxx_Barrier();
       pcxx_UserTimerStop(6);
}
double DistBlkMatrix__SparseMatrix:: getvalue(int r, int c){

       SparseMatrix  *x,*y;
       int i,j,k,l;
       double tmp;
       double  *tmp1;
       int locali;
       i = ComputeMyBlock(cols_per_elem,add_to_elem,c);
       j = ComputeMyIndexInBlock(cols_per_elem,add_to_elem,c);
       k = ComputeMyBlock(cols_per_elem,add_to_elem,r);
       l = ComputeMyIndexInBlock(cols_per_elem,add_to_elem,r);
       if (Is_Local(i,k)) 
       {
          x = (SparseMatrix *) Get_Element(i,k);
          tmp = (x)->value(l,j);
          (x)->tempforgetvalue = tmp;
        }
        _pcxx_Barrier();
       if (Is_Local(0,0)) 
       {
          y = (SparseMatrix *) Get_Element(0,0);
          x = (SparseMatrix *) Get_Element(i,k);
          (y)->tempforgetvalue = (x)->tempforgetvalue;
        }
        _pcxx_Barrier();
       Broadcast();
       locali = GetFirstLocalElementIndex(this );
       if ((locali)>=(0)) 
       {
          tmp = ((*(this ))(locali))->tempforgetvalue;
        }
        else{
          tmp = ((*(this ))(0,0))->tempforgetvalue;
        }
       _pcxx_Barrier();
       return tmp;
}
void  DistBlkMatrix__SparseMatrix:: setvalue(int r, int c, double v){

       SparseMatrix  *x;
       int i,j,k,l;
       i = ComputeMyBlock(cols_per_elem,add_to_elem,c);
       j = ComputeMyIndexInBlock(cols_per_elem,add_to_elem,c);
       k = ComputeMyBlock(cols_per_elem,add_to_elem,r);
       l = ComputeMyIndexInBlock(cols_per_elem,add_to_elem,r);
       if (Is_Local(i,k)) 
       {
          x = (SparseMatrix *) Get_Element(i,k);
          (x)->insert_element(v,l,j);
        }
        _pcxx_Barrier();
}
void  DistBlkMatrix__SparseMatrix:: setplusvalue(int r, int c, double v){

       SparseMatrix  *x;
       int i,j,k,l;
       double t;
       i = ComputeMyBlock(cols_per_elem,add_to_elem,c);
       j = ComputeMyIndexInBlock(cols_per_elem,add_to_elem,c);
       k = ComputeMyBlock(cols_per_elem,add_to_elem,r);
       l = ComputeMyIndexInBlock(cols_per_elem,add_to_elem,r);
       if (Is_Local(i,k)) 
       {
          x = (SparseMatrix *) Get_Element(i,k);
          t = (x)->value(l,j);
          (x)->insert_element((v) + (t),l,j);
        }
        _pcxx_Barrier();
}
int  makea2(int n, int nz, DistBlkMatrix__SparseMatrix &S, double rcond){

       int i,j;
       for (i = 1 ; (i)<=(n) ; (i)++)
       {
          for (j = 1 ; (j)<=(n) ; (j)++)
          {
             if ((i) == (j)) 
             {
                S.setvalue(i,j,(double) 1.0);
              }
              if ((i) == ((j) + (10))) 
             {
                S.setvalue(i,j,(double) 0.01);
              }
              if ((i) == ((j) -(10))) 
             {
                S.setvalue(i,j,(double) 0.01);
              }
            }
        }
       return 1;
}
double  cgsol(int n, DistBlkMatrix__SparseMatrix &S, DistBlkVector__Vector &b, DistBlkVector__Vector &x, int nitcg, DistBlkVector__Vector &r, DistBlkVector__Vector &p, DistBlkVector__Vector &q, NewDistArray__Vector &temp){

       int i,iter;
       double alpha,beta,malpha,rho,rho0,dinv;
       double resid;
       double time;
       ResetLocal(&(x));
       for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
       {
          pcxx_Poll();
          ((x)((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->sub(x,x);
        }
       _pcxx_Barrier();
       ResetLocal(&(r));
       for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
       {
          pcxx_Poll();
          ((r)((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->asgn(b);
        }
       _pcxx_Barrier();
       ResetLocal(&(p));
       for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
       {
          pcxx_Poll();
          ((p)((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->asgn(r);
        }
       _pcxx_Barrier();
       rho = r.dotprod(r);
       for (iter = 1 ; (iter)<=(nitcg) ; (iter)++)
       {
          pcxx_UserTimerStart(1);
          S.MatVec(q,p,temp);
          pcxx_UserTimerStop(1);
          dinv = p.dotprod(q);
          alpha = (rho) / (dinv);
          ResetLocal(&(x));
          for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
          {
             pcxx_Poll();
             ((x)((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->saxpy(alpha,p,x);
           }
          _pcxx_Barrier();
          rho0 = rho;
          malpha =  (-(alpha));
          ResetLocal(&(r));
          for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
          {
             pcxx_Poll();
             ((r)((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->saxpy(malpha,q,r);
           }
          _pcxx_Barrier();
          rho = r.dotprod(r);
          beta = (rho) / (rho0);
          ResetLocal(&(p));
          for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
          {
             pcxx_Poll();
             ((p)((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->saxpy(beta,p,r);
           }
          _pcxx_Barrier();
        }
       pcxx_UserTimerStart(1);
       S.MatVec(r,x,temp);
       pcxx_UserTimerStop(1);
       ResetLocal(&(r));
       for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
       {
          pcxx_Poll();
          ((r)((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->sub(b,r);
        }
       _pcxx_Barrier();
       resid = r.gnorm();
       return resid;
}
void   Processor_Main(){

       double resid,zeta,zeta1,zeta2,zetapr;
       double t0,t1,temps;
       double ops,opscg,time,flops,ratio;
       int i,it,matops,nnzcom,j,reste,elemBl;
       double randlc(double * , double * );
       int makea(int n, int nz, DistBlkMatrix__SparseMatrix &s, double rcond);
       Processors P;
       Distribution T(8,8,&P,4,4);
       Align A(8,0);
       Align B(8,8,1);
       DistBlkMatrix__SparseMatrix S(&T,&B,(1400) + (1),(1400) + (1));
       DistBlkVector__Vector x(&T,&A,(1400) + (1)),z(&T,&A,(1400) + (1)),r(&T,&A,(1400) + (1)),p(&T,&A,(1400) + (1)),q(&T,&A,(1400) + (1));
       DistBlkVector__Vector t(&T,&A,(1400) + (1));
       NewDistArray__Vector  *Temporary;
       if (ev_class&1) 
       {
          se_event(60122,0);
        }
        int nnzchk = 78148;
       double zetchk = 0.10188582986104;
       double zettol = 1.0e-10;
       double reschk = 0.6241e-05;
       double timchk = 1.0538;
       Temporary = new NewDistArray__Vector (&(T),&(B));
       (Temporary)->Set_Block_Size(((1400) / (8)) + (4));
       S.init();
       x.alloc_elements(1);
       z.alloc_elements(0);
       r.alloc_elements(0);
       p.alloc_elements(0);
       q.alloc_elements(0);
       t.alloc_elements(0);
       (GlobalVars[pcxx_NodeNumber()].tran) = 314159265.0;
       (GlobalVars[pcxx_NodeNumber()].amult) = 1220703125.0;
       zeta = randlc(&((GlobalVars[pcxx_NodeNumber()].tran)),&((GlobalVars[pcxx_NodeNumber()].amult)));
       nnzcom = makea(1400,100300,S,0.1);
       _pcxx_Barrier();
       pcxx_UserTimerClear(1);
       pcxx_UserTimerClear(2);
       pcxx_UserTimerClear(3);
       pcxx_UserTimerClear(4);
       pcxx_UserTimerClear(5);
       pcxx_UserTimerClear(6);
       pcxx_UserTimerClear(7);
       if ((pcxx_NodeNumber()) == (0)) 
       {
          printf("=================================================\n");
          printf("= begin output from APP benchmark kernel C  =====\n");
          printf("=================================================\n");
        }
        pcxx_UserTimerClear(0);
       ops = 0.0;
       pcxx_UserTimerStart(0);
       zeta2 = 0.0;
       zeta1 = 0.0;
       zeta = 0.0;
       for (it = 1 ; (it)<=(15) ; (it)++)
       {
          resid = cgsol(1400,S,x,z,25,r,p,q,*(Temporary));
          zeta2 = zeta1;
          zeta1 = zeta;
          zeta = 0.00;
          zeta = z.specialmax(zeta);
          zeta = (1.0) / (zeta);
          zetapr = (zeta) -((((zeta) -(zeta1)) * ((zeta) -(zeta1))) / (((zeta) -((2.0) * (zeta1))) + (zeta2)));
          if ((pcxx_NodeNumber()) == (0)) 
          {
             printf("%5d	%12.4f	  %20.14f\n",it,resid,zetapr);
           }
           ResetLocal(&(x));
          for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
          {
             pcxx_Poll();
             ((x)((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->asgnm(zeta,z);
           }
          _pcxx_Barrier();
        }
       pcxx_UserTimerStop(0);
       if ((pcxx_NodeNumber()) == (0)) 
       {
          temps = pcxx_UserTimerElapsed(1);
          printf("Elapsed time-1 %f\n",temps);
          temps = pcxx_UserTimerElapsed(2);
          printf("Elapsed time-2 %f\n",temps);
          temps = pcxx_UserTimerElapsed(3);
          printf("Elapsed time-3 %f\n",temps);
          temps = pcxx_UserTimerElapsed(4);
          printf("Elapsed time-4 %f\n",temps);
          temps = pcxx_UserTimerElapsed(5);
          printf("Elapsed time-5 %f\n",temps);
          temps = pcxx_UserTimerElapsed(6);
          printf("Elapsed time-6 %f\n",temps);
          matops = (2) * (nnzcom);
          opscg = (double) (((5) * (1400)) + (matops)) + ((25) * (((matops) + ((10) * (1400))) + (2)));
          ops = (double) (15) * ((opscg) + ((double) (1400) + (1)));
          time = pcxx_UserTimerElapsed(0);
          flops = ((1.0e-6) * (ops)) / (time);
          ratio = (timchk) / (time);
          printf("total number of operations	= %16.4f\n",ops);
          printf("total execution time		= %16.4f\n",time);
          printf("performance in mflops		= %16.4f\n",flops);
          printf("ratio: this machine / ymp(1cpu)	= %16.4f\n",ratio);
          if ((nnzchk)!=(nnzcom)) 
          {
             printf("******* kernel failed accuracy check	    ****\n");
             printf("******* number of nonzeros does not match ****\n");
             printf("computed number of nonzeros	    = %d\n",nnzcom);
             printf("correct  number of nonzeros	    = %d\n",nnzchk);
           }
           printf("******* comparison for accuracy check ****\n");
          printf("computed number of nonzeros	= %d\n",nnzcom);
          printf("correct  number of nonzeros	= %d\n",nnzchk);
          printf("computed zeta			= %f\n",zetapr);
          printf("reference value			= %f\n",zetchk);
          printf("computed residual 		= %f\n",resid);
          printf("reference value			= %f\n",reschk);
          printf("=================================================\n");
          printf("= end of output from APP benchmark kernel C =====\n");
          printf("=================================================\n");
          if ((((zetapr) -(zetchk)) >  (1.e-3)) || (((zetapr) -(zetchk)) < ( (-(1.e-3))))) 
          {
             Message("Execution status: Failure.",1);
           }
         }
 }
int  makea(int n, int nz, DistBlkMatrix__SparseMatrix &S, double rcond){

       int i,nnza,iouter,ivelt,ivelt1,jcol,nzv,tt;
       double size,ratio,scale;
       double v[20];
       int iv[20];
       int sparse(DistBlkMatrix__SparseMatrix &S, int n, int arow, int acol, double aelt);
       void  sprnvc(int n, int nz, double *v, int *iv);
       void  vecset(int n, double *v, int *iv, int *nzv, int i, double val);
       size = 1.0;
       ratio = pow(rcond,(double) (1.0) / ((double) n));
       nnza = 0;
       for (iouter = 1 ; (iouter)<=(n) ; (iouter)++)
       {
          nzv = 7;
          sprnvc(n,nzv,v,iv);
          vecset(n,v,iv,&(nzv),iouter,.50);
          for (ivelt = 1 ; (ivelt)<=(nzv) ; (ivelt)++)
          {
             if ((ivelt)>=(20)) 
             {
                printf("Out Of Range %d\n",ivelt);
              }
              jcol = iv[ivelt];
             scale = (size) * (v[ivelt]);
             for (ivelt1 = 1 ; (ivelt1)<=(nzv) ; (ivelt1)++)
             {
                nnza += sparse(S,n,iv[ivelt1],jcol,(v[ivelt1]) * (scale));
              }
           }
          size = (size) * (ratio);
        }
       for (i = 1 ; (i)<=(n) ; (i)++)
       {
          nnza += sparse(S,n,i,i,rcond);
        }
       if ((pcxx_NodeNumber()) == (0)) 
       {
          printf(" matrix size is %d\n",n);
          printf(" final nonzero count for sparse matrix\n");
          printf(" number of nonzeros = %d\n",nnza);
        }
        return nnza;
}
int  sparse(DistBlkMatrix__SparseMatrix &S, int n, int arow, int acol, double aelt){

       int nza;
       double t;
       nza = 0;
       S.setplusvalue(arow,acol,aelt);
       return 0;
}
void   sprnvc(int n, int nz, double *v, int *iv){

       int nn1;
       int nzcol,nzv,i,j,found;
       double randlc(double * , double * );
       int icnvrt(double , int );
       double vecelt,vecloc;
       nzv = 0;
       nzcol = 0;
       nn1 = 1;
       do {

          nn1 = (2) * (nn1);
        } while ((nn1) < (n));
       while ((nzv) < (nz))
       {
          vecelt = randlc(&((GlobalVars[pcxx_NodeNumber()].tran)),&((GlobalVars[pcxx_NodeNumber()].amult)));
          vecloc = randlc(&((GlobalVars[pcxx_NodeNumber()].tran)),&((GlobalVars[pcxx_NodeNumber()].amult)));
          i = (icnvrt(vecloc,nn1)) + (1);
          if ((i)<=(n)) 
          {
             found = 0;
             for (j = 1 ; (j)<=(nzv) ; (j)++)
             {
                if ((iv[j]) == (i)) 
                {
                   found = 1;
                 }
               }
             if ((found) == (0)) 
             {
                (nzv)++;
                if ((nzv)>=(20)) 
                {
                   printf("Out Of Range %d\n",nzv);
                 }
                 v[nzv] = vecelt;
                iv[nzv] = i;
              }
            }
         }
}
int  icnvrt(double x, int ipwr2){

       int icnvr;
       icnvr = (int) floor((ipwr2) * (x));
       return icnvr;
}
void   vecset(int n, double *v, int *iv, int *nzv, int i, double val){

       int set,k;
       set = 0;
       for (k = 1 ; (k)<=(*(nzv)) ; (k)++)
       {
          if ((k)>=(20)) 
          {
             printf("Out Of Range %d\n",k);
           }
           if ((iv[k]) == (i)) 
          {
             v[k] = val;
             set = 1;
           }
         }
       if ((set) == (0)) 
       {
          *(nzv) = (*(nzv)) + (1);
          if ((*(nzv))>=(20)) 
          {
             printf("Out Of Range %d\n",*(nzv));
           }
           v[*(nzv)] = val;
          iv[*(nzv)] = i;
        }
 }
double  randlc(double *x, double *a){

       double t1,t2,t3,t4,a1,a2,x1,x2,z;
       int i;
       if (((GlobalVars[pcxx_NodeNumber()].ks)) == (0)) 
       {
          (GlobalVars[pcxx_NodeNumber()].r23) = 1.0;
          (GlobalVars[pcxx_NodeNumber()].r46) = 1.0;
          (GlobalVars[pcxx_NodeNumber()].t23) = 1.0;
          (GlobalVars[pcxx_NodeNumber()].t46) = 1.0;
          for (i = 0 ; (i) < (24) ; (i)++)
          {
             (GlobalVars[pcxx_NodeNumber()].r23) = (0.50) * ((GlobalVars[pcxx_NodeNumber()].r23));
             (GlobalVars[pcxx_NodeNumber()].t23) = (2.0) * ((GlobalVars[pcxx_NodeNumber()].t23));
           }
          for (i = 1 ; (i) < (47) ; (i)++)
          {
             (GlobalVars[pcxx_NodeNumber()].r46) = (0.50) * ((GlobalVars[pcxx_NodeNumber()].r46));
             (GlobalVars[pcxx_NodeNumber()].t46) = (2.0) * ((GlobalVars[pcxx_NodeNumber()].t46));
           }
          (GlobalVars[pcxx_NodeNumber()].ks) = 1;
        }
        t1 = ((GlobalVars[pcxx_NodeNumber()].r23)) * (*(a));
       a1 = floor(t1);
       a2 = (*(a)) -(((GlobalVars[pcxx_NodeNumber()].t23)) * (a1));
       t1 = ((GlobalVars[pcxx_NodeNumber()].r23)) * (*(x));
       x1 = floor(t1);
       x2 = (*(x)) -(((GlobalVars[pcxx_NodeNumber()].t23)) * (x1));
       t1 = ((a1) * (x2)) + ((a2) * (x1));
       t2 = floor(((GlobalVars[pcxx_NodeNumber()].r23)) * (t1));
       z = (t1) -(((GlobalVars[pcxx_NodeNumber()].t23)) * (t2));
       t3 = (((GlobalVars[pcxx_NodeNumber()].t23)) * (z)) + ((a2) * (x2));
       t4 = floor(((GlobalVars[pcxx_NodeNumber()].r46)) * (t3));
       *(x) = (t3) -(((GlobalVars[pcxx_NodeNumber()].t46)) * (t4));
       return ((GlobalVars[pcxx_NodeNumber()].r46)) * (*(x));
}

#include "align_function.h"

void DuplicateGlobalVars(int num_threads)
{ 
  int i;
   
  GlobalVars = (GVars *) malloc ( sizeof(GVars) * num_threads );

  for(i=0;i<num_threads;i++)
   {
     (GlobalVars[i].ks)=0;
    }
}
