//  ----------------------------------
//  Darryl Brown
//  University of Oregon pC++/Sage++
//
//  TItypeDesc.h  -- 
//
//  
//  ----------------------------------


#ifdef TYPE_DESCR_INC 

// already included, do nothing

#else 

#define TYPE_DESCR_INC

#include "TIbasics.h"

// a class for specifying a type ;
class brk_aType : public brk_basicAType {
 public:
  SgType *sageType;
  brk_aType();
  brk_aType(char *desc, int ty);
  brk_aType(SgType *ty);
};


// a class for specifying a type ;
class brk_pType : public brk_basicPType  {
 public:
  SgType *sageType;
  // the type of the elements stored int the pointer;
  brk_pType(SgType *ty);
};

class brk_sComposite;

class brk_sField : public brk_aField {
 public:
  virtual void writeFieldAccess(brk_sComposite *parent);
  virtual SgStatement * writePtrAccessFunc(SgFile *f, brk_sComposite *parent);
  virtual SgStatement * addPtrAccessCond(SgFile *f, brk_sComposite *parent,
					 SgStatement *fhs);
  brk_sField(brk_basicAType *f, char *n);
  brk_sField();
};


// a class for representing a pointer field withing a composite data
// structure.;
class brk_pField : public brk_sField {
 public:
  void writeFieldAccess(SgFile *f, brk_aComposite *parent);
  brk_pField(brk_aType *at, char *n);
};


// an extension of the brk_aComposite class, changing methods for 
// generating access funcitons in from text output to sage output.
class brk_sComposite : public brk_aComposite {
 public:
  SgStatement * writeAccessFields(SgFile *f, SgStatement *st);
  SgStatement *writeAccessFunction(SgFile *f);
  brk_sComposite(char * aName);
  brk_sComposite(char * aName, int t);
  brk_sComposite(char * aName, SgStatement *ds);
  brk_sComposite(char * aName, int t, SgStatement *ds);
  SgStatement *declStmt;
};


class brk_sCompositeList : public brk_compositeList {
 public:
  void writeAccessEntries(SgFile *f);
  SgStatement *writeAccessFunctions(SgFile *f);
  brk_sCompositeList();
  brk_sCompositeList(char *name);
};


// extern declarations.
extern void brk_buildTypesFromFile(SgFile *aFile);
extern void brk_determineSuperClasses(classHierarchy *ch);
extern brk_aComposite * brk_getOrMakeComposite(brk_basicAType *ctype);
extern void brk_addFieldToComposite(brk_basicAType *ctype,
		    char *fieldName, brk_basicAType *fieldType);
extern void brk_mySageInit();
#endif







