//  ----------------------------------
//  Darryl Brown
//  University of Oregon pC++/Sage++
//
//  sage++breakpoint-rt.h  -  module for inspecting a pC++ program
//       at breakpoints that can be compiled into the runtime 
//       system.
//
//  
//  ----------------------------------

//if already included, skip this file...
#ifdef BPRT_ALREADY_INCLUDED
// do nothing;
#else 
#define BPRT_ALREADY_INCLUDED 1

// This points to the queue which names of collection variables are
//  placed just before they are created.
extern brk_linkedList *brk_BPcollDeclQueue;

// This points to the tables (list) of collection instances and a record
// of information about them.
extern brk_linkedList *brk_BPcollInstanceTable;

// communications;
extern FILE *brk_openOutFile();
extern FILE *brk_openInFile();

// forward declaratin off this function.;
extern void brk_QUE_COLLECTION_INSTANCE (char *collName, char *elemType, 
                              char *varName);

// adds a collection to the collection instance table;
void brk_ADD_COLLECTION_ENTRY(int numElems, int sizeElem, Kernel *newC);

extern int brk_BREAKPOINT_TOGGLE_VAR;
#define brk_TOGGLE_BREAKPOINT (brk_BREAKPOINT_TOGGLE_VAR *= -1)

// here is the endif 

#endif

