/***************************************************************************
 * Program:         ENVOY EUI Communication Library
 *
 * Module:          mpeui.h
 *
 * Purpose:         EUI c interface routines to mp_ (fortran
 *                      interface) routines
 *
 * Classification:  IBM Internal Use Only
 *
 * Author:          Peter de Jong
 *
 *                  10/29/92 Last Update
 ***************************************************************************/
 
#ifndef MPEUI
#define MPEUI
 
int mp_brecv (char *, int *, int *, int *, int *);

int mp_bsend (char *, int *, int *, int*);
 
int mp_bsendrecv (char *, int *, int *, int *, char *, int *, int *, int *);
 
int mp_environ (int *, int *);
 
int mp_recv (char *, int *, int *, int *, int *);
 
int mp_send (char *, int *, int *, int *, int *);
 
int mp_status (int *);

int mp_stopall (int *);
 
int mp_task_query (int [], int *, int *);
 
int mp_task_set (int [], int *);
 
int mp_wait (int *, int *);

int mp_bcast (char *, int *, int *, int *);

int mp_combine (char *, char *, int *, int (*)(), int *);

int mp_concat (char *, char *, int *, int *);
 
int mp_gather (char *, char *, int *, int *, int *);
 
int mp_index (char *, char *, int *, int *);

int mp_prefix (char *, char *, int *, int (*)(), int  *);

int mp_reduce (char *, char *, int *, int *, int (*)(), int *);
 
int mp_scatter (char *, char *, int *, int *,  int *);
 
int mp_shift (char *, char *, int *, int *, int *, int *);
 
int mp_sync (int *);
 
int mp_getlabel (int *, int *);
 
int mp_getmembers (int [], int *);
 
int mp_getrank (int *, int *, int *);
 
int mp_getsize (int *, int *);
 
int mp_gettaskid  (int *, int *, int *);

int mp_group (int *, int [], int *, int *);
 
int mp_partition (int *, int *, int *, int *);
 
int _ccl_pack0 (char *, int, int, int, char *);
 
int _ccl_unpack0 (char *, int, int, int, char *);
 
#endif


